"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithLink = exports.WithoutDismiss = exports.WithoutPrefix = exports.Plaintext = exports.Emphasized = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var _1 = require(".");
var __1 = require("../../");
exports.default = {
    title: 'Core/Alert',
    component: _1.Alert,
};
var Template = utils_1.createTemplate(_1.Alert);
exports.Default = utils_1.createStory(Template, {
    success: true,
    children: 'This is a default alert',
});
exports.Emphasized = utils_1.createStory(Template, {
    info: true,
    emphasized: true,
    children: 'This is an emphasized alert',
});
exports.Plaintext = utils_1.createStory(Template, {
    info: true,
    plaintext: true,
    children: 'This is a plaintext alert',
});
exports.WithoutPrefix = utils_1.createStory(Template, {
    success: true,
    children: 'Without a prefix',
});
exports.WithoutDismiss = utils_1.createStory(Template, {
    success: true,
    children: 'Without a dismiss button',
});
exports.WithLink = utils_1.createStory(Template, {
    success: true,
    children: (react_1.default.createElement(react_1.default.Fragment, null,
        "With a ",
        react_1.default.createElement(__1.Link, { href: "test" }, "link"))),
});
