"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Emphasized = exports.WithImage = exports.WithLastName = exports.WithFirstName = exports.WithFullName = exports.Default = void 0;
var utils_1 = require("../../stories/utils");
var _1 = require(".");
exports.default = {
    title: 'Core/Avatar',
    component: _1.Avatar,
};
var Template = utils_1.createTemplate(_1.Avatar);
exports.Default = utils_1.createStory(Template, {});
exports.WithFullName = utils_1.createStory(Template, {
    firstName: 'John',
    lastName: 'Doe',
});
exports.WithFirstName = utils_1.createStory(Template, {
    firstName: 'John',
});
exports.WithLastName = utils_1.createStory(Template, {
    lastName: 'Doe',
});
exports.WithImage = utils_1.createStory(Template, {
    src: 'https://dashboard.balena-cloud.com/img/logo.svg',
});
exports.Emphasized = utils_1.createStory(Template, {
    firstName: 'John',
    lastName: 'Doe',
    emphasized: true,
});
