/// <reference types="react" />
import { AlignSelfProps, FlexProps as StyledFlexProps, OrderProps } from 'styled-system';
import { RenditionSystemProps } from '../../common-types';
export interface BoxProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'color'>, StyledFlexProps, OrderProps, AlignSelfProps, RenditionSystemProps {
}
export declare const Box: import("react").ForwardRefExoticComponent<BoxProps & import("react").RefAttributes<HTMLDivElement>>;
