import * as React from 'react';
export interface Crumb {
    text?: string;
    component?: JSX.Element;
    href?: string;
    icon?: React.ReactNode;
    onClick?: (event: React.MouseEvent) => void;
    secondaryIcon?: React.ReactNode;
}
export interface BreadcrumbsProps {
    crumbs: Crumb[];
    emphasized?: boolean;
    dark?: boolean;
    isCollapsed?: boolean;
}
export declare const Breadcrumbs: ({ crumbs, isCollapsed, emphasized, dark, }: BreadcrumbsProps) => JSX.Element;
