"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Disabled = exports.BlankTarget = exports.Default = void 0;
var utils_1 = require("../../stories/utils");
var _1 = require(".");
exports.default = {
    title: 'Core/Link',
    component: _1.Link,
};
var Template = utils_1.createTemplate(_1.Link);
exports.Default = utils_1.createStory(Template, {
    href: '#',
    children: 'Internal link',
});
exports.BlankTarget = utils_1.createStory(Template, {
    href: 'https://balena.io',
    blank: true,
});
exports.Disabled = utils_1.createStory(Template, {
    href: 'https://balena.io',
    disabled: true,
});
