"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Ordered = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var _1 = require(".");
var __1 = require("../..");
var defaultChildren = [
    react_1.default.createElement(__1.Txt, null,
        "You can put ",
        react_1.default.createElement(__1.Link, { href: '#' }, "a link")),
    react_1.default.createElement(__1.Txt, null,
        "And also some ",
        react_1.default.createElement("code", null, "code")),
    react_1.default.createElement(__1.Txt, null,
        "Multiline text",
        react_1.default.createElement(__1.Txt, null, "that breaks into multiple lines")),
];
exports.default = {
    title: 'Core/List',
    component: _1.List,
};
var Template = utils_1.createTemplate(_1.List);
exports.Default = utils_1.createStory(Template, {
    children: defaultChildren,
});
exports.Ordered = utils_1.createStory(Template, {
    ordered: true,
    children: defaultChildren,
});
