"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Fuzzy = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var _1 = require(".");
var PagerDemo = function (props) {
    var _a = react_1.default.useState(props.page), page = _a[0], setPage = _a[1];
    return (react_1.default.createElement(_1.Pager, __assign({}, props, { page: page, nextPage: function () { return setPage(page + 1); }, prevPage: function () { return setPage(page - 1); } })));
};
exports.default = {
    title: 'Core/Pager',
    component: _1.Pager,
};
var Template = utils_1.createTemplate(PagerDemo);
exports.Default = utils_1.createStory(Template, {
    totalItems: 436,
    itemsPerPage: 50,
    page: 1,
    nextPage: function () { return null; },
    prevPage: function () { return null; },
});
exports.Fuzzy = utils_1.createStory(Template, {
    totalItems: 200,
    itemsPerPage: 50,
    page: 1,
    nextPage: function () { return null; },
    prevPage: function () { return null; },
    fuzzy: true,
});
