import { RendererProps } from '../index';
declare type UiSchemaMetaSchema = {
    title?: string;
    description?: string;
    type: string | string[];
    properties: {
        [key: string]: any;
    };
};
declare type MetaSchemaArgs = Pick<RendererProps, 'value' | 'schema' | 'uiSchema' | 'extraContext' | 'extraFormats'>;
export declare const generateUiSchemaMetaSchema: ({ value: unprocessedValue, uiSchema, schema, extraContext, extraFormats, }: MetaSchemaArgs) => UiSchemaMetaSchema;
export {};
