"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithChildren = exports.WithComponentLabel = exports.WithLabel = exports.Emphasized = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var __1 = require("../../");
var _1 = require(".");
exports.default = {
    title: 'Core/Spinner',
    component: _1.Spinner,
};
var Template = utils_1.createTemplate(_1.Spinner);
exports.Default = utils_1.createStory(Template, {});
exports.Emphasized = utils_1.createStory(Template, {
    emphasized: true,
});
exports.WithLabel = utils_1.createStory(Template, {
    label: 'Spinning...',
});
exports.WithComponentLabel = utils_1.createStory(Template, {
    label: (react_1.default.createElement(__1.Txt, { color: "text.main" },
        "Building image ",
        react_1.default.createElement(__1.Button, { plain: true }, "12345"),
        "...")),
});
exports.WithChildren = utils_1.createStory(Template, {
    label: 'Spinning...',
    children: (react_1.default.createElement(__1.Box, { p: 5, style: { backgroundColor: '#f8f9fd' } }, "Spinning, the wrapped children are made opaque")),
});
