import * as React from 'react';
import { TagLabelProps } from './TagLabel';
import { TxtProps } from '../Txt';
import { ResourceTagBase } from '../TagManagementModal/models';
export declare const TagLabel: React.ComponentType<TagLabelProps>;
interface TagLabelListProps extends TxtProps {
    tags: ResourceTagBase[];
    nowrap?: boolean;
}
interface TagLabelListState {
    sortedTags: ResourceTagBase[];
}
export declare class TagLabelList extends React.Component<TagLabelListProps, TagLabelListState> {
    constructor(props: TagLabelListProps);
    componentDidMount(): void;
    componentWillReceiveProps({ tags }: TagLabelListProps): void;
    render(): JSX.Element;
}
export {};
