"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableRow = exports.Table = exports.TableColumnSelectorSizer = void 0;
var React = __importStar(require("react"));
var TableBase_1 = require("./TableBase");
var styled_components_1 = __importStar(require("styled-components"));
var keys_1 = __importDefault(require("lodash/keys"));
var pick_1 = __importDefault(require("lodash/pick"));
var filter_1 = __importDefault(require("lodash/filter"));
var map_1 = __importDefault(require("lodash/map"));
var flatMap_1 = __importDefault(require("lodash/flatMap"));
var uniq_1 = __importDefault(require("lodash/uniq"));
var reduce_1 = __importDefault(require("lodash/reduce"));
var without_1 = __importDefault(require("lodash/without"));
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var keyBy_1 = __importDefault(require("lodash/keyBy"));
var Flex_1 = require("../Flex");
var TableColumnSelector_1 = require("./TableColumnSelector");
var TagLabel_1 = require("./TagLabel");
var TagLabelList_1 = require("./TagLabelList");
var CustomColumnHeader_1 = require("./CustomColumnHeader");
var TableRow_1 = require("./TableRow");
Object.defineProperty(exports, "TableRow", { enumerable: true, get: function () { return TableRow_1.TableRow; } });
var tag_management_service_1 = require("../TagManagementModal/tag-management-service");
var utils_1 = require("../../utils");
var Container = styled_components_1.default(Flex_1.Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tposition: relative;\n"], ["\n\tposition: relative;\n"])));
exports.TableColumnSelectorSizer = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tposition: absolute;\n\ttop: ", ";\n\tright: 0;\n\tdisplay: flex;\n\talign-items: center;\n\theight: 40px;\n\tpadding: 0 8px;\n\tbackground: ", ";\n"], ["\n\tposition: absolute;\n\ttop: ", ";\n\tright: 0;\n\tdisplay: flex;\n\talign-items: center;\n\theight: 40px;\n\tpadding: 0 8px;\n\tbackground: ", ";\n"])), function (props) { return (props.pagerPosition === 'bottom' ? 0 : '47px'); }, function (props) { return props.theme.colors.quartenary.semilight; });
var fixedFirstColumnWidth = '60px';
var fixedFirstColumnCss = function (bg) { return styled_components_1.css(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tmax-width: calc(100% - ", ");\n\tmargin-left: ", ";\n\n\twhite-space: nowrap;\n\n\t> [data-display='table-head']\n\t\t> [data-display='table-row']\n\t\t> [data-display='table-cell'],\n\t> [data-display='table-body']\n\t\t> [data-display='table-row']\n\t\t> [data-display='table-cell'] {\n\t\t&:first-child {\n\t\t\tposition: absolute;\n\t\t\tleft: 0;\n\t\t\tdisplay: flex;\n\t\t\talign-items: center;\n\t\t\twidth: ", ";\n\t\t\theight: inherit;\n\t\t\tz-index: 3;\n\t\t\tbackground-color: inherit;\n\t\t\t> input[type='checkbox'] {\n\t\t\t\tmargin: 0;\n\t\t\t}\n\t\t}\n\t}\n\t> [data-display='table-head']\n\t\t> [data-display='table-row']\n\t\t> [data-display='table-cell']:first-child {\n\t\tbackground-color: ", ";\n\t}\n"], ["\n\tmax-width: calc(100% - ", ");\n\tmargin-left: ", ";\n\n\twhite-space: nowrap;\n\n\t> [data-display='table-head']\n\t\t> [data-display='table-row']\n\t\t> [data-display='table-cell'],\n\t> [data-display='table-body']\n\t\t> [data-display='table-row']\n\t\t> [data-display='table-cell'] {\n\t\t&:first-child {\n\t\t\tposition: absolute;\n\t\t\tleft: 0;\n\t\t\tdisplay: flex;\n\t\t\talign-items: center;\n\t\t\twidth: ", ";\n\t\t\theight: inherit;\n\t\t\tz-index: 3;\n\t\t\tbackground-color: inherit;\n\t\t\t> input[type='checkbox'] {\n\t\t\t\tmargin: 0;\n\t\t\t}\n\t\t}\n\t}\n\t> [data-display='table-head']\n\t\t> [data-display='table-row']\n\t\t> [data-display='table-cell']:first-child {\n\t\tbackground-color: ", ";\n\t}\n"])), fixedFirstColumnWidth, fixedFirstColumnWidth, fixedFirstColumnWidth, bg); };
var StyledTable = styled_components_1.default(TableBase_1.TableBase)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\t", ";\n\n\t> [data-display='table-head'] > [data-display='table-row'] {\n\t\theight: 42px;\n\t}\n\n\t> [data-display='table-body'] > [data-display='table-row'] {\n\t\theight: 50px;\n\t}\n\n\t", ";\n"], ["\n\t",
    ";\n\n\t> [data-display='table-head'] > [data-display='table-row'] {\n\t\theight: 42px;\n\t}\n\n\t> [data-display='table-body'] > [data-display='table-row'] {\n\t\theight: 50px;\n\t}\n\n\t",
    ";\n"])), function (props) {
    return props.enableCustomColumns
        ? "\n\t\t> [data-display='table-head']\n\t\t\t> [data-display='table-row']\n\t\t\t> [data-display='table-cell']:last-child {\n\t\t\tpadding-right: 50px;\n\t\t}\n\t"
        : '';
}, function (props) {
    return !!props.onCheck
        ? fixedFirstColumnCss(props.theme.colors.quartenary.semilight)
        : '';
});
var TypedTable = StyledTable;
var TAGS_COLUMN_KEY = 'Tags';
var tagCellAttributes = {
    href: undefined,
    style: {
        cursor: 'auto',
        paddingTop: '6px',
        paddingBottom: '6px',
    },
};
var isCustomTagColumn = function (column) {
    return column.type === 'tag' && column.key !== TAGS_COLUMN_KEY;
};
var insertTagColumns = function (columns, newTagColumns) {
    var allTagsColumnIndex = columns.findIndex(function (column) { return column.key === TAGS_COLUMN_KEY; });
    if (allTagsColumnIndex < 0) {
        allTagsColumnIndex = columns.length - 1;
    }
    columns.splice.apply(columns, __spreadArrays([allTagsColumnIndex, 0], newTagColumns));
};
var findTagOfTaggedResource = function (taggedResource, tagField, tagKey) { var _a; return (_a = tag_management_service_1.getResourceTags(taggedResource, tagField)) === null || _a === void 0 ? void 0 : _a.find(function (tag) { return tag.tag_key === tagKey; }); };
var getTagTableColumn = function (columnState, tagField) {
    var column = __assign(__assign({}, columnState), { field: tagField + "." + columnState.tagKey, cellAttributes: tagCellAttributes });
    column.sortable = function (a, b) {
        var tagKey = column.tagKey;
        if (!tagKey) {
            return 0;
        }
        var item1tag = findTagOfTaggedResource(a, tagField, tagKey);
        var item2tag = findTagOfTaggedResource(b, tagField, tagKey);
        if (!item1tag && !item2tag) {
            return 0;
        }
        if (!item1tag) {
            return 1;
        }
        if (!item2tag) {
            return -1;
        }
        return (item1tag.value || '').localeCompare(item2tag.value || '');
    };
    column.render = function (_value, data) {
        var tagKey = column.tagKey;
        if (!tagKey) {
            return null;
        }
        var tag = findTagOfTaggedResource(data, tagField, tagKey);
        if (!tag) {
            return null;
        }
        return React.createElement(TagLabel_1.TagLabel, { tag: tag, showTagKey: false });
    };
    return column;
};
var normalizeTableColumn = function (originalColumn, enableCustomColumns) {
    var column = originalColumn;
    if (isCustomTagColumn(column) && !column.title && column.tagKey) {
        column.title = column.tagKey;
    }
    column.label = column.label || column.title;
    column.selected =
        !enableCustomColumns ||
            originalColumn.locked ||
            originalColumn.selected ||
            false;
    return column;
};
var getAllTagsTableColumn = function (tagField, enableCustomColumns) {
    return normalizeTableColumn({
        title: 'Tags',
        key: TAGS_COLUMN_KEY,
        selected: false,
        type: 'predefined',
        field: tagField,
        cellAttributes: tagCellAttributes,
        render: function (tags) {
            if (!tags) {
                return null;
            }
            return React.createElement(TagLabelList_1.TagLabelList, { tags: tags, nowrap: true });
        },
    }, enableCustomColumns);
};
var loadSortingPreferences = function (sortingStateRestorationKey) {
    if (!sortingStateRestorationKey) {
        return;
    }
    var sortPreferences = utils_1.getFromLocalStorage(sortingStateRestorationKey);
    if (!sortPreferences || !sortPreferences.field) {
        return;
    }
    return sortPreferences;
};
var saveSortingPreferences = function (sortingStateRestorationKey, sortPreferences) {
    if (!sortingStateRestorationKey) {
        return;
    }
    utils_1.setToLocalStorage(sortingStateRestorationKey, sortPreferences);
};
var loadColumnPreferences = function (columnStateRestorationKey) {
    if (!columnStateRestorationKey) {
        return [];
    }
    var loadedColumns = utils_1.getFromLocalStorage(columnStateRestorationKey);
    loadedColumns === null || loadedColumns === void 0 ? void 0 : loadedColumns.forEach(function (c) {
        if (c.type === 'tag' && !c.tagKey) {
            c.tagKey = undefined;
        }
    });
    return loadedColumns;
};
var saveColumnPreferences = function (columnStateRestorationKey, newColumns) {
    if (!columnStateRestorationKey) {
        return;
    }
    var savePayload = newColumns.map(function (c) {
        return pick_1.default(c, TableColumnSelector_1.TableColumnStateStoredProps);
    });
    utils_1.setToLocalStorage(columnStateRestorationKey, savePayload);
};
var applyColumnPreferences = function (columns, loadedColumns, tagField, enableCustomColumns) {
    if (!(loadedColumns === null || loadedColumns === void 0 ? void 0 : loadedColumns.length)) {
        return columns;
    }
    var columnsByKey = keyBy_1.default(columns, 'key');
    var loadedColumnsByKey = keyBy_1.default(loadedColumns, 'key');
    var tableColumnStateAssignedProps = without_1.default(TableColumnSelector_1.TableColumnStateStoredProps, 'key');
    keys_1.default(columnsByKey).forEach(function (key) {
        var column = columnsByKey[key];
        var loadedColumn = loadedColumnsByKey[key];
        if (!loadedColumn || !column) {
            return;
        }
        Object.assign(column, pick_1.default(loadedColumn, tableColumnStateAssignedProps));
    });
    if (tagField) {
        var loadedTagColumns = filter_1.default(loadedColumns, isCustomTagColumn);
        var tagColumns = map_1.default(loadedTagColumns, function (c) {
            return getTagTableColumn(c, tagField);
        });
        insertTagColumns(columns, tagColumns);
    }
    columns.forEach(function (column) {
        return normalizeTableColumn(column, enableCustomColumns);
    });
    return columns;
};
var addCustomColumns = function (props) {
    var columns = props.columns, tagField = props.tagField, enableCustomColumns = props.enableCustomColumns, columnStateRestorationKey = props.columnStateRestorationKey;
    var allColumns = columns.map(function (column) {
        return normalizeTableColumn(column, enableCustomColumns);
    });
    if (tagField) {
        allColumns = allColumns.concat(getAllTagsTableColumn(tagField, enableCustomColumns));
    }
    var loadedColumns = props.loadColumnPreferences
        ? props.loadColumnPreferences()
        : loadColumnPreferences(columnStateRestorationKey);
    allColumns = applyColumnPreferences(allColumns, loadedColumns, tagField, enableCustomColumns);
    return allColumns;
};
var Table = (function (_super) {
    __extends(Table, _super);
    function Table(props) {
        var _this = _super.call(this, props) || this;
        _this.setColumnsAndSave = function (columns) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.setColumns(columns)];
                    case 1:
                        _a.sent();
                        this.saveColumnPreferences(columns);
                        return [2];
                }
            });
        }); };
        _this.addTagColumn = function () {
            var _a = _this.state, tagKeys = _a.tagKeys, newTagColumnKeys = _a.newTagColumnKeys, allColumns = _a.allColumns, selectedTagColumnKeys = _a.selectedTagColumnKeys;
            if (!_this.props.tagField) {
                return;
            }
            if (allColumns.some(function (c) { return c.type === 'tag' && c.tagKey === undefined; })) {
                return;
            }
            var tagKey = newTagColumnKeys.length === 1 ? newTagColumnKeys[0] : undefined;
            var newColumnState = TableColumnSelector_1.getNewTagTableColumnState(tagKey);
            var columns = allColumns.slice();
            var newTagColumn = getTagTableColumn(newColumnState, _this.props.tagField);
            _this.setTagTableColumnHeader({ tagKeys: tagKeys, selectedTagColumnKeys: selectedTagColumnKeys }, newTagColumn);
            insertTagColumns(columns, [newTagColumn]);
            _this.setColumnsAndSave(columns);
        };
        _this.configureTagColumn = function (column, tagKey) {
            if (!column || !tagKey || !_this.props.tagField) {
                return;
            }
            var indexOfColumn = _this.state.allColumns.indexOf(column);
            if (indexOfColumn < 0) {
                return;
            }
            var newColumn = getTagTableColumn(TableColumnSelector_1.getNewTagTableColumnState(tagKey), _this.props.tagField);
            var columns = _this.state.allColumns.slice();
            columns.splice(indexOfColumn, 1, newColumn);
            _this.setColumnsAndSave(columns);
        };
        _this.onSort = function (sort) {
            if (_this.props.sortingStateRestorationKey) {
                saveSortingPreferences(_this.props.sortingStateRestorationKey, sort);
                _this.setState({
                    sort: sort,
                });
            }
            if (_this.props.onSort) {
                _this.props.onSort(sort);
            }
        };
        var allColumns = addCustomColumns(props);
        _this.state = _this.getNewStateSlice(allColumns, _this.props.data);
        return _this;
    }
    Table.prototype.componentWillReceiveProps = function (newProps) {
        var _this = this;
        if (this.props.data !== newProps.data ||
            this.props.columns !== newProps.columns) {
            var allColumns = this.state.allColumns;
            if (this.props.columns !== newProps.columns) {
                allColumns = addCustomColumns(newProps);
            }
            var newStateSlice_1 = this.getNewStateSlice(allColumns, newProps.data);
            var shouldSaveUpdatedColumns_1 = !isEqual_1.default(map_1.default(this.state.visibleColumns, 'key'), map_1.default(newStateSlice_1.visibleColumns, 'key'));
            this.setState(newStateSlice_1, function () {
                if (shouldSaveUpdatedColumns_1) {
                    _this.saveColumnPreferences(newStateSlice_1.allColumns);
                }
            });
        }
    };
    Table.prototype.getTagKeys = function (columns, data) {
        var _this = this;
        if (!this.props.tagField) {
            return {
                tagKeys: [],
                selectedTagColumnKeys: [],
                newTagColumnKeys: [],
            };
        }
        var tagKeys = uniq_1.default(flatMap_1.default(data, function (d) {
            return tag_management_service_1.getResourceTags(d, _this.props.tagField) || [];
        }).map(function (t) { return t.tag_key; })).sort();
        var selectedTagColumnKeys = reduce_1.default(columns, function (acc, c) {
            if (c.type === 'tag' && c.tagKey) {
                acc.push(c.tagKey);
            }
            return acc;
        }, []);
        var newTagColumnKeys = without_1.default.apply(void 0, __spreadArrays([tagKeys], selectedTagColumnKeys));
        if (!this.state ||
            !isEqual_1.default(this.state.tagKeys, tagKeys) ||
            !isEqual_1.default(this.state.selectedTagColumnKeys, selectedTagColumnKeys) ||
            !isEqual_1.default(this.props.columns, columns)) {
            var addedFirstTag_1 = !!this.state && !this.state.tagKeys.length && tagKeys.length;
            columns = columns.map(function (c) {
                if (isCustomTagColumn(c)) {
                    _this.setTagTableColumnHeader({ tagKeys: tagKeys, selectedTagColumnKeys: selectedTagColumnKeys }, c);
                }
                else if (addedFirstTag_1 && c.key === TAGS_COLUMN_KEY && !c.selected) {
                    c.selected = true;
                }
                return c;
            });
        }
        return { tagKeys: tagKeys, selectedTagColumnKeys: selectedTagColumnKeys, newTagColumnKeys: newTagColumnKeys };
    };
    Table.prototype.getNewStateSlice = function (columns, data) {
        var visibleColumns = filter_1.default(columns, 'selected');
        var sort;
        if (this.state) {
            sort = this.state.sort;
        }
        else if (!this.props.sort && this.props.sortingStateRestorationKey) {
            var loadedSort_1 = loadSortingPreferences(this.props.sortingStateRestorationKey);
            if (loadedSort_1 &&
                visibleColumns.some(function (c) { return c.field === loadedSort_1.field; })) {
                sort = loadedSort_1;
            }
        }
        return __assign({ allColumns: columns, visibleColumns: visibleColumns,
            sort: sort }, this.getTagKeys(columns, data));
    };
    Table.prototype.setColumns = function (newColumns) {
        var _this = this;
        var newState = this.getNewStateSlice(newColumns.slice(), this.props.data);
        return new Promise(function (resolve) { return _this.setState(newState, resolve); });
    };
    Table.prototype.saveColumnPreferences = function (newColumns) {
        if (this.props.saveColumnPreferences) {
            this.props.saveColumnPreferences(newColumns);
        }
        else {
            saveColumnPreferences(this.props.columnStateRestorationKey, newColumns);
        }
    };
    Table.prototype.setTagTableColumnHeader = function (state, column) {
        column.label = (React.createElement(CustomColumnHeader_1.CustomColumnHeader, { columnInfo: column, items: state.tagKeys, disabledItems: state.selectedTagColumnKeys, label: "Tag", setColumn: this.configureTagColumn }));
    };
    Table.prototype.render = function () {
        var _a = this.props, columns = _a.columns, tagField = _a.tagField, sortingStateRestorationKey = _a.sortingStateRestorationKey, columnStateRestorationKey = _a.columnStateRestorationKey, loadColumnPreferences = _a.loadColumnPreferences, saveColumnPreferences = _a.saveColumnPreferences, sortProp = _a.sort, innerRef = _a.innerRef, onSort = _a.onSort, onRowClick = _a.onRowClick, props = __rest(_a, ["columns", "tagField", "sortingStateRestorationKey", "columnStateRestorationKey", "loadColumnPreferences", "saveColumnPreferences", "sort", "innerRef", "onSort", "onRowClick"]);
        var sort = sortProp || (sortingStateRestorationKey ? this.state.sort : undefined);
        return (React.createElement(Container, null,
            React.createElement(Flex_1.Flex, { flexDirection: "column", flex: "1", width: "100%" },
                React.createElement(TypedTable, __assign({ columns: this.state.visibleColumns, ref: innerRef, sort: sort, onSort: this.onSort, onRowClick: onRowClick }, props))),
            this.props.enableCustomColumns && (React.createElement(exports.TableColumnSelectorSizer, { pagerPosition: props.pagerPosition },
                React.createElement(TableColumnSelector_1.TableColumnSelector, { columns: this.state.allColumns, setColumns: this.setColumnsAndSave, addTagColumn: this.addTagColumn, tagKeys: tagField ? this.state.tagKeys : undefined })))));
    };
    return Table;
}(React.Component));
exports.Table = Table;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
