"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddTagForm = void 0;
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var uuid = __importStar(require("uuid"));
var find_1 = __importDefault(require("lodash/find"));
var startsWith_1 = __importDefault(require("lodash/startsWith"));
var isEmpty_1 = __importDefault(require("lodash/isEmpty"));
var Alert_1 = require("../Alert");
var Txt_1 = require("../Txt");
var Input_1 = require("../Input");
var Button_1 = require("../Button");
var SimpleConfirmationModal_1 = require("../../internal/SimpleConfirmationModal");
var utils_1 = require("../../utils");
var useTranslation_1 = require("../../hooks/useTranslation");
var Alert = styled_components_1.default(Alert_1.Alert)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tpadding: 8px 0 18px;\n"], ["\n\tpadding: 8px 0 18px;\n"])));
var NewTagTr = styled_components_1.default.tr(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\ttable > thead > & > td {\n\t\tpadding-top: 0;\n\t\tpadding-bottom: 0;\n\t}\n"], ["\n\ttable > thead > & > td {\n\t\tpadding-top: 0;\n\t\tpadding-bottom: 0;\n\t}\n"])));
var NewTagErrorsTr = styled_components_1.default.tr(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\ttable > thead > & > td {\n\t\theight: 30px;\n\t\tpadding-top: 5px;\n\t\tpadding-bottom: 5px;\n\t}\n"], ["\n\ttable > thead > & > td {\n\t\theight: 30px;\n\t\tpadding-top: 5px;\n\t\tpadding-bottom: 5px;\n\t}\n"])));
var RESERVED_NAMESPACE = 'io.resin.';
var newTagValidationRules = function (t, key, existingTags) {
    return [
        {
            test: function () { return !key || isEmpty_1.default(key); },
            message: t('fields_errors.tag_name_cannot_be_empty'),
        },
        {
            test: function () { return /\s/.test(key); },
            message: t('fields_errors.tag_names_cannot_contain_whitespace'),
        },
        {
            test: function () { return startsWith_1.default(key, RESERVED_NAMESPACE); },
            message: t("fields_errors.some_tag_keys_are_reserved", {
                namespace: RESERVED_NAMESPACE,
            }),
        },
        {
            test: function () {
                return existingTags.some(function (tag) { return tag.state !== 'deleted' && tag.tag_key === key; });
            },
            message: t('fields_errors.tag_with_same_name_exists'),
        },
    ];
};
exports.AddTagForm = function (_a) {
    var itemType = _a.itemType, existingTags = _a.existingTags, overwritableTags = _a.overwritableTags, addTag = _a.addTag;
    var t = useTranslation_1.useTranslation().t;
    var _b = React.useState(''), tagKey = _b[0], setTagKey = _b[1];
    var _c = React.useState(''), value = _c[0], setValue = _c[1];
    var _d = React.useState(false), tagKeyIsInvalid = _d[0], setTagKeyIsInvalid = _d[1];
    var _e = React.useState(), error = _e[0], setError = _e[1];
    var _f = React.useState(false), canSubmit = _f[0], setCanSubmit = _f[1];
    var _g = React.useState(), confirmationModalOptions = _g[0], setConfirmationModalOptions = _g[1];
    var tagKeyInput = React.useRef(null);
    var valueInput = React.useRef(null);
    var formUuid = "add-tag-form-" + uuid.v1();
    var checkNewTagValidity = function (key) {
        var failedRule = newTagValidationRules(t, key, existingTags).find(function (rule) { return rule.test(); });
        var hasErrors = !!failedRule;
        setTagKeyIsInvalid(hasErrors);
        setError(failedRule);
        setCanSubmit(!hasErrors);
        return hasErrors;
    };
    var checkTagOverwrites = function () { return __awaiter(void 0, void 0, void 0, function () {
        var overwritableTag, count, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    overwritableTag = find_1.default(overwritableTags || [], {
                        tag_key: tagKey,
                    });
                    if (!overwritableTag) {
                        return [2, true];
                    }
                    count = overwritableTag.items.length;
                    return [4, new Promise(function (resolve) {
                            var confirmationModalOptions = {
                                title: t('warnings.this_would_overwrite_tags', {
                                    itemType: itemType,
                                    count: count,
                                }),
                                children: (React.createElement(Txt_1.Txt, null,
                                    t("warnings.tag_name_group_exists_and_will_be_overwritten", {
                                        itemType: itemType,
                                        count: count,
                                    }),
                                    React.createElement("br", null),
                                    t('actions_confirmations.confirm_to_proceed'))),
                                action: t('actions.continue'),
                                onClose: resolve,
                            };
                            setConfirmationModalOptions(confirmationModalOptions);
                        })];
                case 1:
                    result = _a.sent();
                    setConfirmationModalOptions(undefined);
                    return [2, result];
            }
        });
    }); };
    var internalAddTag = utils_1.withPreventDefault(function () {
        if (checkNewTagValidity(tagKey)) {
            return;
        }
        return checkTagOverwrites().then(function (confirmed) {
            if (!confirmed) {
                return;
            }
            addTag({
                tag_key: tagKey,
                value: value,
            });
            setTagKey('');
            setValue('');
            setTagKeyIsInvalid(false);
            setError(undefined);
            setCanSubmit(false);
            if (tagKeyInput && tagKeyInput.current) {
                tagKeyInput.current.blur();
            }
            if (valueInput && valueInput.current) {
                valueInput.current.blur();
            }
        });
    });
    return (React.createElement("thead", null,
        React.createElement(NewTagTr, { onKeyDown: function (e) { return utils_1.stopKeyDownEvent(e, 13, internalAddTag); } },
            React.createElement("td", null),
            React.createElement("td", null,
                React.createElement(Input_1.Input, { form: formUuid, width: "100%", ref: tagKeyInput, onChange: function (e) {
                        setTagKey(e.target.value);
                        checkNewTagValidity(e.target.value);
                    }, value: tagKey, invalid: tagKeyIsInvalid, placeholder: t('labels.tag_name') })),
            React.createElement("td", null,
                React.createElement(Input_1.Input, { form: formUuid, width: "100%", ref: valueInput, onChange: function (e) { return setValue(e.target.value); }, value: value, placeholder: t('labels.value') })),
            React.createElement("td", null,
                React.createElement("form", { id: formUuid, onSubmit: internalAddTag },
                    React.createElement(Button_1.Button, { width: "120px", tertiary: true, onClick: internalAddTag, disabled: !canSubmit }, t('actions.add_tag'))),
                confirmationModalOptions && (React.createElement(SimpleConfirmationModal_1.SimpleConfirmationModal, __assign({}, confirmationModalOptions))))),
        React.createElement(NewTagErrorsTr, null,
            React.createElement("td", null),
            React.createElement("td", { colSpan: 2 }, error && (React.createElement(Alert, { danger: true, plaintext: true }, error.message))),
            React.createElement("td", null))));
};
var templateObject_1, templateObject_2, templateObject_3;
