"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CollectionSummary = void 0;
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var index_1 = require("../../../index");
var Txt_1 = require("../../Txt");
var utils_1 = require("../../../utils");
var CaretButton_1 = require("./CaretButton");
var Container = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tfont-size: 16px;\n\tfont-weight: normal;\n\tcolor: #b3b6b9;\n"], ["\n\tfont-size: 16px;\n\tfont-weight: normal;\n\tcolor: #b3b6b9;\n"])));
var ItemNameHolder = styled_components_1.default(Txt_1.Txt)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tfont-size: 0.9em;\n\twhite-space: normal;\n\tcolor: ", ";\n"], ["\n\tfont-size: 0.9em;\n\twhite-space: normal;\n\tcolor: ", ";\n"])), function (prop) { return prop.color || ''; });
var CollectionSummary = (function (_super) {
    __extends(CollectionSummary, _super);
    function CollectionSummary(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            isExpanded: !!_this.props.initiallyExpanded,
        };
        return _this;
    }
    CollectionSummary.prototype.render = function () {
        var _this = this;
        var _a = this.props, items = _a.items, itemsType = _a.itemsType, maxVisibleItemCount = _a.maxVisibleItemCount;
        var itemNameColor = utils_1.getThemeColoring(index_1.Theme, this.props, 'main');
        return (React.createElement(Container, null,
            items.length === 1 && React.createElement(Txt_1.Txt, { color: itemNameColor }, items[0]),
            items.length > 1 && (React.createElement("div", null,
                React.createElement(CaretButton_1.CaretButton, { isExpanded: this.state.isExpanded, onClick: function () {
                        return _this.setState({
                            isExpanded: !_this.state.isExpanded,
                        });
                    } },
                    React.createElement("span", null, items.length + " " + itemsType)),
                this.state.isExpanded && (React.createElement(ItemNameHolder, { color: itemNameColor }, maxVisibleItemCount && items.length > maxVisibleItemCount
                    ? items.slice(0, maxVisibleItemCount).join(', ') + ", ..."
                    : items.join(', ')))))));
    };
    return CollectionSummary;
}(React.Component));
exports.CollectionSummary = CollectionSummary;
var templateObject_1, templateObject_2;
