"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TagLabelList = exports.TagLabel = void 0;
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var TagLabel_1 = require("./TagLabel");
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var map_1 = __importDefault(require("lodash/map"));
var sortBy_1 = __importDefault(require("lodash/sortBy"));
var Flex_1 = require("../Flex");
exports.TagLabel = styled_components_1.default(TagLabel_1.TagLabel)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: inline-flex;\n\tmax-width: 200px;\n"], ["\n\tdisplay: inline-flex;\n\tmax-width: 200px;\n"])));
var getDefaultState = function () { return ({
    sortedTags: [],
}); };
var TagLabelList = (function (_super) {
    __extends(TagLabelList, _super);
    function TagLabelList(props) {
        var _this = _super.call(this, props) || this;
        _this.state = getDefaultState();
        return _this;
    }
    TagLabelList.prototype.componentDidMount = function () {
        this.setState({ sortedTags: sortBy_1.default(this.props.tags || [], 'tag_key') });
    };
    TagLabelList.prototype.componentWillReceiveProps = function (_a) {
        var tags = _a.tags;
        if (!this.state.sortedTags || !isEqual_1.default(this.props.tags, tags)) {
            this.setState({ sortedTags: sortBy_1.default(tags || [], 'tag_key') });
        }
    };
    TagLabelList.prototype.render = function () {
        var _a = this.props, tags = _a.tags, nowrap = _a.nowrap, restProps = __rest(_a, ["tags", "nowrap"]);
        return (React.createElement(Flex_1.Flex, __assign({ mx: "-5px", flexWrap: nowrap ? 'nowrap' : 'wrap' }, restProps), map_1.default(this.state.sortedTags, function (tag) { return (React.createElement(exports.TagLabel, { key: tag.tag_key, tag: tag, mx: "5px", my: nowrap ? undefined : '5px' })); })));
    };
    return TagLabelList;
}(React.Component));
exports.TagLabelList = TagLabelList;
var templateObject_1;
