"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.table = void 0;
var react_1 = __importDefault(require("react"));
var faTable_1 = require("@fortawesome/free-solid-svg-icons/faTable");
var Table_1 = require("../../../../components/Table");
exports.table = {
    slug: 'table',
    name: 'Default table lens',
    data: {
        label: 'Table',
        format: 'table',
        renderer: function (_a) {
            var filtered = _a.filtered, selected = _a.selected, properties = _a.properties, hasUpdateActions = _a.hasUpdateActions, changeSelected = _a.changeSelected, data = _a.data, autouiContext = _a.autouiContext, onEntityClick = _a.onEntityClick;
            return (react_1.default.createElement(Table_1.Table, __assign({ rowKey: "id", data: filtered, checkedItems: selected, columns: properties }, (hasUpdateActions && { onCheck: changeSelected }), { usePager: data && data.length > 5, pagerPosition: "bottom", itemsPerPage: 50, getRowHref: autouiContext.getBaseUrl, onRowClick: onEntityClick, columnStateRestorationKey: autouiContext.resource + "__columns", sortingStateRestorationKey: autouiContext.resource + "__sort", tagField: autouiContext.tagField, enableCustomColumns: true })));
        },
        icon: faTable_1.faTable,
        type: '*',
        filter: {
            type: 'array',
            items: {
                type: 'object',
                properties: {
                    id: {
                        type: 'number',
                    },
                },
            },
        },
    },
};
