import { AutoUIBaseResource, AutoUIRawModel } from '../schemaOps';
export interface AugmentedSshKey extends AutoUIBaseResource<AugmentedSshKey> {
    title: string;
    description: string;
    public_key: string;
    id: number;
    fingerprint?: string;
}
export declare const model: AutoUIRawModel<AugmentedSshKey>;
export declare const transformers: {
    __permissions: () => import("../schemaOps").Permissions<AugmentedSshKey>;
};
export declare const dataExample: {
    id: number;
    title: string;
    description: string;
    public_key: string;
    fingerprint: string;
}[];
