"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFieldForFormat = exports.autoUIJsonSchemaPick = void 0;
var pick_1 = __importDefault(require("lodash/pick"));
exports.autoUIJsonSchemaPick = function (schema, selectors) {
    var _a, _b;
    var res = __assign(__assign({}, schema), { properties: pick_1.default((_a = schema.properties) !== null && _a !== void 0 ? _a : {}, selectors), required: [] });
    res.required = (_b = schema.required) === null || _b === void 0 ? void 0 : _b.filter(function (requiredField) {
        return selectors.includes(requiredField);
    });
    return res;
};
exports.getFieldForFormat = function (schema, format) {
    var _a;
    var propertyKeyWithFormat;
    Object.entries((_a = schema.properties) !== null && _a !== void 0 ? _a : {}).forEach(function (_a) {
        var key = _a[0], val = _a[1];
        if (typeof val === 'object' && val.format === format) {
            propertyKeyWithFormat = key;
        }
    });
    return propertyKeyWithFormat;
};
