"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var enzyme_1 = require("enzyme");
var __1 = require("../..");
var index_1 = require("./index");
var example_1 = require("./models/example");
var props = {};
var TestAutoUI = function () { return react_1.default.createElement(Demo, __assign({}, props)); };
var Demo = function (_a) {
    var data = _a.data, model = _a.model, otherProps = __rest(_a, ["data", "model"]);
    var memoizedData = react_1.default.useMemo(function () {
        return index_1.autoUIRunTransformers(example_1.dataExample, example_1.transformers, {
            accessRole: 'administrator',
        });
    }, [example_1.dataExample]);
    return (react_1.default.createElement(index_1.AutoUI, __assign({ data: data !== null && data !== void 0 ? data : memoizedData, model: model !== null && model !== void 0 ? model : index_1.autoUIGetModelForCollection(example_1.model), actions: [] }, otherProps)));
};
describe('AutoUI', function () {
    describe('Collection component', function () {
        it('should render the collection with N results', function () {
            var component = enzyme_1.mount(react_1.default.createElement(__1.Provider, null,
                react_1.default.createElement(TestAutoUI, null)));
            var table = component.find(__1.Table);
            var tableRows = table.find('[data-display="table-body"] [data-display="table-row"]');
            expect(tableRows).toHaveLength(example_1.dataExample.length);
        });
    });
});
