import { AutoUIBaseResource, Permissions, Priorities } from './schemaOps';
import { TFunction } from '../../hooks/useTranslation';
import { TableSortFunction } from '../../components/Table/TableRow';
import type { JSONSchema7 as JSONSchema } from 'json-schema';
export declare const history: import("history").History<unknown>;
export declare const findInObject: (obj: any, key: string) => any;
export declare const ObjectFromEntries: (entries: any[]) => any;
export declare const getTagsDisabledReason: <T extends AutoUIBaseResource<T>>(selected: T[], tagField: keyof T, t: TFunction) => string | false;
export declare const getCreateDisabledReason: <T extends AutoUIBaseResource<T>>(permissions: Permissions<T>, hasOngoingAction: boolean, t: TFunction) => string | undefined;
export declare const autoUIGetDisabledReason: <T extends AutoUIBaseResource<T>>(selected: T[], hasOngoingAction: boolean, actionType: 'update' | 'delete' | null, t: TFunction) => string | undefined;
export declare const getSortingFunction: <T extends unknown>(schemaKey: keyof T, schemaValue: JSONSchema) => TableSortFunction<T>;
export declare const getSelected: <T, K extends keyof T>(key: K, priorities?: Priorities<T> | undefined) => boolean;
export declare const onClickOutOrEsc: (wrapper: HTMLDivElement, callback: () => void) => void;
