import { OsVersion } from './models';
export declare type VersionSelectionOptions = {
    title: string;
    value: string;
    isRecommended?: boolean;
    osType: string;
    line?: string;
    knownIssueList: string | null;
} & ({
    hasPrebuiltVariants: false;
    rawVersion: string;
} | {
    hasPrebuiltVariants: true;
    rawVersions: {
        dev?: string;
        prod?: string;
    };
});
export declare const transformVersions: (versions: OsVersion[]) => VersionSelectionOptions[];
export declare const getPreferredVersionOpts: (versionOpts: VersionSelectionOptions[]) => VersionSelectionOptions[];
