import { CheckBoxProps as GrommetCheckBoxProps } from 'grommet';
import * as React from 'react';
import { RenditionSystemProps } from '../../common-types';
export declare const getHoverStyle: (props: any) => string;
export interface InternalCheckboxProps extends React.HTMLAttributes<HTMLElement>, GrommetCheckBoxProps {
    onChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
}
export declare type CheckboxProps = InternalCheckboxProps & RenditionSystemProps;
export declare const Checkbox: React.FunctionComponent<CheckboxProps>;
