import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { Box, Tag, Table, Txt } from '../..';
import { Copy } from '.';
var columns = [{ field: 'Name' }, { field: 'Value' }];
var data = [
    { Name: 'Type', Value: 'Beginner' },
    { Name: 'Type', Value: 'Advanced' },
];
export default {
    title: 'Core/Copy',
    component: Copy,
};
var Template = createTemplate(Copy);
export var Default = createStory(Template, {
    content: 'Plain text',
    children: React.createElement(Txt, null, "Hover me and click on icon to copy"),
});
export var WithTag = createStory(Template, {
    content: 'Beginner',
    children: React.createElement(Tag, { name: "Type", value: "Beginner" }),
});
export var AlwaysShow = createStory(Template, {
    content: JSON.stringify(data),
    children: React.createElement(Table, { columns: columns, data: data }),
});
export var IconOnly = createStory(Template, {
    content: 'Hi there',
});
IconOnly.decorators = [
    function (Story) { return (React.createElement(Box, { m: 3 },
        "Only copy icon that can be placed anywhere.",
        React.createElement(Story, null))); },
];
