import React from 'react';
export interface DataGridProps<T> {
    items: T[];
    renderItem: (item: T) => React.ReactNode;
    getItemKey: (item: T) => string | number;
    itemMinWidth: number | string | number[] | string[];
    itemMaxWidth?: number | string | number[] | string[];
}
export declare const DataGrid: <T extends unknown>({ itemMinWidth, itemMaxWidth, items, renderItem, getItemKey, }: DataGridProps<T>) => JSX.Element;
