import { __makeTemplateObject } from "tslib";
import React from 'react';
import styled from 'styled-components';
import { px } from '../../utils';
import { useBreakpoint } from '../../hooks/useBreakpoint';
var Base = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: grid;\n\tjustify-content: left;\n\tgrid-gap: ", ";\n\tgrid-template-columns: ", ";\n"], ["\n\tdisplay: grid;\n\tjustify-content: left;\n\tgrid-gap: ", ";\n\tgrid-template-columns: ",
    ";\n"])), function (props) { return px(props.theme.space[4]); }, function (props) {
    return "repeat(auto-fill, minmax(" + props.itemMinWidth + ", 1fr))";
});
var BaseItem = styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tmin-width: ", ";\n\tmax-width: ", ";\n"], ["\n\tmin-width: ", ";\n\tmax-width: ", ";\n"])), function (props) { return props.itemMinWidth; }, function (props) { return props.itemMaxWidth; });
var BaseDataGrid = function (_a) {
    var itemMinWidth = _a.itemMinWidth, itemMaxWidth = _a.itemMaxWidth, items = _a.items, renderItem = _a.renderItem, getItemKey = _a.getItemKey;
    var currentMinWidth = useBreakpoint(itemMinWidth);
    var currentMaxWidth = useBreakpoint(itemMaxWidth !== null && itemMaxWidth !== void 0 ? itemMaxWidth : '100%');
    return (React.createElement(Base, { itemMinWidth: currentMinWidth, itemMaxWidth: currentMaxWidth }, items.map(function (item) { return (React.createElement(BaseItem, { key: getItemKey(item), itemMinWidth: currentMinWidth, itemMaxWidth: currentMaxWidth }, renderItem(item))); })));
};
export var DataGrid = BaseDataGrid;
var templateObject_1, templateObject_2;
