import * as React from 'react';
import { Coloring, RenditionSystemProps, Theme } from '../../common-types';
import { TxtProps } from '../Txt';
export interface InternalHighlightedNameProps extends TxtProps, Coloring {
    children: string;
    className?: string;
    color?: string;
    bg?: string;
}
export interface ThemedHighlightedNameProps extends InternalHighlightedNameProps {
    theme: Theme;
}
export declare type HighlightedNameProps = InternalHighlightedNameProps & RenditionSystemProps;
export declare const HighlightedName: React.FunctionComponent<HighlightedNameProps>;
