import { GrommetProps } from 'grommet';
import * as React from 'react';
import { Theme } from '../../common-types';
import { WidgetContextValue } from '../../contexts/WidgetContext';
import type { History } from 'history';
export interface ThemedProvider extends Omit<React.HTMLAttributes<HTMLElement>, 'dir'> {
    widgets?: WidgetContextValue;
    theme?: Partial<Theme>;
    dir?: GrommetProps['dir'];
    t?: any;
    history?: History;
}
export declare const Provider: ({ theme, widgets, t, history, ...props }: ThemedProvider) => JSX.Element;
