import React from 'react';
import { Copy } from '../../Copy';
import { Flex } from '../../Flex';
import { Txt } from '../../Txt';
import { JsonTypes } from '../types';
import { widgetFactory } from './widget-util';
export var DisabledTextWidget = widgetFactory('DisabledText', {}, [
    JsonTypes.string,
    JsonTypes.number,
])(function (_a) {
    var value = _a.value;
    var val = typeof value !== 'string' ? value.toString() : value;
    return (React.createElement(Flex, null,
        React.createElement(Txt, { maxWidth: "300px", truncate: true, title: val, color: "#b3b6b9", monospace: true }, val),
        val.length > 45 && React.createElement(Copy, { content: val })));
});
