import React from 'react';
import { Txt } from '../../Txt';
import { JsonTypes } from '../types';
import { UiOption } from './ui-options';
import { widgetFactory } from './widget-util';
import { formatTimestamp, timeSince } from './widget-util';
export var ElapsedTimeWidget = widgetFactory('ElapsedTime', {
    dtFormat: UiOption.string,
}, [JsonTypes.string, JsonTypes.number])(function (_a) {
    var value = _a.value;
    if (!value) {
        return null;
    }
    return React.createElement(Txt, { tooltip: formatTimestamp(value) }, timeSince(value));
});
