import * as React from 'react';
import { RenditionSystemProps } from '../../common-types';
export interface InternalSearchProps extends React.HTMLAttributes<HTMLElement> {
    dark?: boolean;
    disabled?: boolean;
    placeholder?: string;
    value?: string;
    onChange?: (value: any) => void;
    onEnter?: () => void;
}
export declare type SearchProps = InternalSearchProps & RenditionSystemProps;
export declare const Search: React.ForwardRefExoticComponent<InternalSearchProps & import("../../common-types").StyledSystemProps & import("../../common-types").Tooltip & React.RefAttributes<HTMLInputElement>>;
