import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { Button, Box, Txt } from '../../';
import { Spinner } from '.';
export default {
    title: 'Core/Spinner',
    component: Spinner,
};
var Template = createTemplate(Spinner);
export var Default = createStory(Template, {});
export var Emphasized = createStory(Template, {
    emphasized: true,
});
export var WithLabel = createStory(Template, {
    label: 'Spinning...',
});
export var WithComponentLabel = createStory(Template, {
    label: (React.createElement(Txt, { color: "text.main" },
        "Building image ",
        React.createElement(Button, { plain: true }, "12345"),
        "...")),
});
export var WithChildren = createStory(Template, {
    label: 'Spinning...',
    children: (React.createElement(Box, { p: 5, style: { backgroundColor: '#f8f9fd' } }, "Spinning, the wrapped children are made opaque")),
});
