import { __assign, __makeTemplateObject, __rest } from "tslib";
import styled from 'styled-components';
import { Tab as GrommetTab, Tabs as GrommetTabs, } from 'grommet';
import React from 'react';
import asRendition from '../../asRendition';
var ScrollWrapper = styled(GrommetTabs)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tposition: relative;\n\tdisplay: flex;\n\talign-items: stretch;\n\theight: 100%;\n\n\tdiv[role='tabpanel'] {\n\t\tdisplay: flex;\n\t\tflex: 1;\n\t}\n\n\t", "\n"], ["\n\tposition: relative;\n\tdisplay: flex;\n\talign-items: stretch;\n\theight: 100%;\n\n\tdiv[role='tabpanel'] {\n\t\tdisplay: flex;\n\t\tflex: 1;\n\t}\n\n\t",
    "\n"])), function (props) {
    if (props.compact) {
        return "\n\t\t\t\twidth: 100%;\n\n\t\t\t\t& > div {\n\t\t\t\t\tscroll-snap-type: x mandatory;\n\t\t\t\t\toverflow-x: scroll;\n\t\t\t\t\tdisplay: flex;\n\t\t\t\t\tflex-wrap: nowrap;\n\t\t\t\t}\n\n\t\t\t\tdiv[role=tabpanel] {\n\t\t\t\t\toverflow-x: auto;\n\t\t\t\t}\n\t\t\t\t\n\t\t\t\tdiv > button[role=tab] > div {\n\t\t\t\t\twhite-space: nowrap;\n\t\t\t\t\toverflow: hidden;\n\t\t\t\t\ttext-overflow: ellipsis;\n\t\t\t\t\tscroll-snap-align: center;\n\t\t\t\t}\n\t\t\t";
    }
});
export var Tab = function (props) { return React.createElement(GrommetTab, __assign({}, props)); };
var TabsBase = function (_a) {
    var children = _a.children, _b = _a.compact, compact = _b === void 0 ? false : _b, props = __rest(_a, ["children", "compact"]);
    return (React.createElement(ScrollWrapper, __assign({ justify: "start", compact: compact }, props), children));
};
export var Tabs = asRendition(TabsBase);
var templateObject_1;
