import React from 'react';
import { PersistentFilters } from './PersistentFilters';
import { Filters as RenditionFilters, } from '../../../components/Filters';
import { useHistory } from '../../../hooks/useHistory';
export var Filters = function (_a) {
    var schema = _a.schema, filters = _a.filters, views = _a.views, changeFilters = _a.changeFilters, changeViews = _a.changeViews, autouiContext = _a.autouiContext, renderMode = _a.renderMode, onSearch = _a.onSearch;
    var history = useHistory();
    return (React.createElement(React.Fragment, null, !!history ? (React.createElement(PersistentFilters, { compact: [true, true, false, false], viewsRestorationKey: autouiContext.resource + "__views", history: history, schema: schema, filters: filters, views: views, onFiltersUpdate: changeFilters, onViewsUpdate: changeViews, renderMode: renderMode !== null && renderMode !== void 0 ? renderMode : ['add', 'search', 'views'], onSearch: onSearch })) : (React.createElement(RenditionFilters, { compact: [true, true, false, false], schema: schema, filters: filters, views: views, onFiltersUpdate: changeFilters, onViewsUpdate: changeViews, renderMode: renderMode !== null && renderMode !== void 0 ? renderMode : ['add', 'search', 'views'], onSearch: onSearch }))));
};
