/// <reference types="react" />
import { AutoUIContext } from '../schemaOps';
import { AutoUIModel } from '..';
interface FocusSearchProps<T extends {
    id: number;
    [key: string]: any;
}> {
    searchTerm: string;
    filtered: T[];
    selected: T[];
    setSelected: (selected: T[]) => void;
    autouiContext: AutoUIContext<T>;
    model: AutoUIModel<T>;
    hasUpdateActions?: boolean;
}
export declare const FocusSearch: <T extends {
    [key: string]: any;
    id: number;
}>({ searchTerm, filtered, selected, setSelected, autouiContext, model, hasUpdateActions, }: FocusSearchProps<T>) => JSX.Element;
export {};
