import { __assign, __rest } from "tslib";
import React from 'react';
import { Box } from '../../../components/Box';
import { Button } from '../../../components/Button';
import { ButtonGroup } from '../../../components/ButtonGroup';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
export var LensSelection = function (_a) {
    var lenses = _a.lenses, lens = _a.lens, setLens = _a.setLens, rest = __rest(_a, ["lenses", "lens", "setLens"]);
    if (lenses.length <= 1) {
        return null;
    }
    return (React.createElement(Box, __assign({}, rest),
        React.createElement(ButtonGroup, null, lenses.map(function (item) {
            return (React.createElement(Button, { key: item.slug, active: lens && lens.slug === item.slug, "data-test": "lens-selector--" + item.slug, "data-slug": item.slug, onClick: function () { return setLens(item); }, tooltip: {
                    text: item.data.label,
                    placement: 'bottom',
                }, icon: React.createElement(FontAwesomeIcon, { icon: item.data.icon }), quartenary: true, outline: true }));
        }))));
};
