import { __assign } from "tslib";
import $pick from 'lodash/pick';
export var autoUIJsonSchemaPick = function (schema, selectors) {
    var _a, _b;
    var res = __assign(__assign({}, schema), { properties: $pick((_a = schema.properties) !== null && _a !== void 0 ? _a : {}, selectors), required: [] });
    res.required = (_b = schema.required) === null || _b === void 0 ? void 0 : _b.filter(function (requiredField) {
        return selectors.includes(requiredField);
    });
    return res;
};
export var getFieldForFormat = function (schema, format) {
    var _a;
    var propertyKeyWithFormat;
    Object.entries((_a = schema.properties) !== null && _a !== void 0 ? _a : {}).forEach(function (_a) {
        var key = _a[0], val = _a[1];
        if (typeof val === 'object' && val.format === format) {
            propertyKeyWithFormat = key;
        }
    });
    return propertyKeyWithFormat;
};
