/// <reference types="react" />
import { OpenApiJson } from './openApiJson';
export declare const ACTION_SIDEBAR_WIDTH = 340;
declare global {
    interface Window {
        REACT_APP_API_HOST: string;
        REACT_APP_TITLE: string;
    }
}
export declare enum ActionMethods {
    POST = "post",
    PATCH = "patch",
    DELETE = "delete"
}
export interface AutoUIAppProps {
    openApiJson: OpenApiJson;
    title: string;
    logo?: string;
}
export declare const AutoUIApp: ({ openApiJson, title, logo }: AutoUIAppProps) => JSX.Element;
