import unified from 'unified';
export interface Decorator {
    match: RegExp;
    captureGroupIndex?: number;
    component: string;
    properties?: any;
    ignoreCodeBlock?: boolean;
}
interface DecoratorPluginOptions {
    decorators: Decorator[] | undefined;
}
export declare const decoratorPlugin: unified.Plugin<[DecoratorPluginOptions]>;
export {};
