/// <reference types="react" />
import { DeviceTypeOptions } from './models';
export declare const DownloadImageLabel: import("styled-components").StyledComponent<"label", any, {}, never>;
export interface FormModel {
    [key: string]: boolean | number | string | undefined;
}
interface DownloadFormModelProps {
    model: FormModel;
    onModelChange: (model: FormModel) => void;
    options: DeviceTypeOptions[];
}
export declare const DownloadFormModel: ({ model, onModelChange, options, }: DownloadFormModelProps) => JSX.Element | null;
export {};
