import { __assign, __makeTemplateObject } from "tslib";
import { faEye } from '@fortawesome/free-solid-svg-icons/faEye';
import { faEyeSlash } from '@fortawesome/free-solid-svg-icons/faEyeSlash';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import * as React from 'react';
import { Button } from '../../components/Button';
import { Input } from '../../components/Input';
import styled from 'styled-components';
var Container = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tposition: relative;\n"], ["\n\tposition: relative;\n"])));
var HideButton = styled(Button)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tposition: absolute;\n\tright: 16px;\n\ttop: 50%;\n\ttransform: translate(0, -50%);\n"], ["\n\tposition: absolute;\n\tright: 16px;\n\ttop: 50%;\n\ttransform: translate(0, -50%);\n"])));
export var PasswordInput = function (props) {
    var _a = React.useState(false), showPassword = _a[0], setShowPassword = _a[1];
    return (React.createElement(Container, null,
        React.createElement(Input, __assign({}, props, { mb: 0, pr: 5, type: showPassword ? 'text' : 'password' })),
        React.createElement(HideButton, { plain: true, icon: showPassword ? (React.createElement(FontAwesomeIcon, { icon: faEye })) : (React.createElement(FontAwesomeIcon, { icon: faEyeSlash })), onClick: function () { return setShowPassword(function (x) { return !x; }); } })));
};
var templateObject_1, templateObject_2;
