import * as React from 'react';
declare type mapper<TInner, TOutter> = (input: TInner) => TOutter;
declare type InferableComponentEnhancerWithProps<TInjectedProps, TNeedsProps> = <P extends TInjectedProps>(component: React.ComponentType<P>) => React.ComponentClass<Omit<P, keyof TInjectedProps> & TNeedsProps>;
declare type ComponentEnhancer<TInner, TOutter> = (component: React.ComponentType<TInner>) => React.ComponentClass<TOutter>;
export declare function compose<TInner, TOutter>(...funcs: Function[]): ComponentEnhancer<TInner, TOutter>;
export declare function withProps<TInner, TOutter>(fn: TInner | mapper<TOutter, TInner>): InferableComponentEnhancerWithProps<TInner & TOutter, TOutter>;
export {};
