"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropDownButton = void 0;
var faChevronDown_1 = require("@fortawesome/free-solid-svg-icons/faChevronDown");
var faChevronUp_1 = require("@fortawesome/free-solid-svg-icons/faChevronUp");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var useBreakpoint_1 = require("../../hooks/useBreakpoint");
var utils_1 = require("../../utils");
var Box_1 = require("../Box");
var Button_1 = require("../Button");
var Divider_1 = require("../Divider");
var Fixed_1 = require("../Fixed");
var Flex_1 = require("../Flex");
var TOGGLE_BUTTON_X_PADDING = 16;
var CHEVRON_ICON_WIDTH = 12;
var TOGGLE_BUTTON_WIDTH = 2 * TOGGLE_BUTTON_X_PADDING + CHEVRON_ICON_WIDTH;
var ToggleBase = styled_components_1.default(Button_1.Button)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tmin-width: 0;\n\tborder-top-left-radius: 0;\n\tborder-bottom-left-radius: 0;\n\tborder-left: 0;\n\tmargin: 0;\n\tvertical-align: top;\n\tpadding: 0 ", ";\n\twidth: ", ";\n"], ["\n\tmin-width: 0;\n\tborder-top-left-radius: 0;\n\tborder-bottom-left-radius: 0;\n\tborder-left: 0;\n\tmargin: 0;\n\tvertical-align: top;\n\tpadding: 0 ", ";\n\twidth: ", ";\n"])), utils_1.px(TOGGLE_BUTTON_X_PADDING), utils_1.px(TOGGLE_BUTTON_WIDTH));
var ButtonBase = styled_components_1.default(Button_1.Button)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tborder-top-right-radius: 0;\n\tborder-bottom-right-radius: 0;\n\tborder-right: 0;\n\tmargin: 0;\n\twidth: calc(100% - ", ");\n"], ["\n\tborder-top-right-radius: 0;\n\tborder-bottom-right-radius: 0;\n\tborder-right: 0;\n\tmargin: 0;\n\twidth: calc(100% - ", ");\n"])), utils_1.px(TOGGLE_BUTTON_WIDTH));
var MenuBase = styled_components_1.default(Box_1.Box)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tbackground: white;\n\tposition: absolute;\n\tborder-radius: ", ";\n\tborder: ", ";\n\tz-index: 1;\n\tmargin-top: ", ";\n\tmargin-bottom: ", ";\n\tbottom: ", ";\n\tleft: ", ";\n\tright: ", ";\n\twidth: 200px;\n\toverflow-y: auto;\n\toverflow-x: hidden;\n"], ["\n\tbackground: white;\n\tposition: absolute;\n\tborder-radius: ", ";\n\tborder: ", ";\n\tz-index: 1;\n\tmargin-top: ", ";\n\tmargin-bottom: ", ";\n\tbottom: ", ";\n\tleft: ", ";\n\tright: ", ";\n\twidth: 200px;\n\toverflow-y: auto;\n\toverflow-x: hidden;\n"])), function (props) { return utils_1.px(props.theme.radius); }, function (props) { return '1px solid ' + props.theme.colors.gray.main; }, function (props) { return (props.dropUp ? 0 : '2px'); }, function (props) { return (props.dropUp ? '2px' : 0); }, function (props) { return (props.dropUp ? props.theme.button.height : 'auto'); }, function (props) { return (props.alignRight ? 'auto' : 0); }, function (props) { return (!props.alignRight ? 'auto' : 0); });
var Wrapper = styled_components_1.default(Box_1.Box)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\tdisplay: inline-block;\n\tborder-radius: ", ";\n\tvertical-align: top;\n\tposition: relative;\n\n\tsvg {\n\t\twidth: ", ";\n\t\ttransform: translateY(1px);\n\t}\n"], ["\n\tdisplay: inline-block;\n\tborder-radius: ", ";\n\tvertical-align: top;\n\tposition: relative;\n\n\tsvg {\n\t\twidth: ", ";\n\t\ttransform: translateY(1px);\n\t}\n"])), function (props) { return utils_1.px(props.theme.radius); }, utils_1.px(CHEVRON_ICON_WIDTH));
var getHoverStyle = function (props) { return "\n\t" + (props.hasActionFn &&
    "&:hover {\n\tbackground: #dde1f0; // This is the background color Select uses for entities on hover. We do not have it in our theme\n\tcursor: " + (props.disabled ? 'not-allowed' : 'pointer') + ";}"); };
var getDangerStyle = function (props) { return "\n\t" + (props.danger && "color: " + props.theme.colors.danger.main + ";") + "\n\t"; };
var getDisabledStyle = function (props) { return "\n\t" + (props.disabled && "opacity: 1; color: " + props.theme.colors.gray.main + ";") + "\n\t"; };
var Item = styled_components_1.default(Box_1.Box)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n\t", "\n\t", "\n\t", "\n"], ["\n\t", "\n\t", "\n\t", "\n"])), getHoverStyle, getDangerStyle, getDisabledStyle);
var JoinedButton = styled_components_1.default(Button_1.Button)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n\tmargin: 0;\n\twidth: 100%;\n"], ["\n\tmargin: 0;\n\twidth: 100%;\n"])));
var Toggle = function (_a) {
    var open = _a.open, handler = _a.handler, label = _a.label, joined = _a.joined, compact = _a.compact, items = _a.items, props = __rest(_a, ["open", "handler", "label", "joined", "compact", "items"]);
    var toggleProps = __assign(__assign({}, props), { type: 'button', onClick: handler });
    var icon = open ? faChevronUp_1.faChevronUp : faChevronDown_1.faChevronDown;
    var shouldCompact = useBreakpoint_1.useBreakpoint(compact || [false]);
    if (joined) {
        if (label || props.icon) {
            return (React.createElement(JoinedButton, __assign({}, toggleProps),
                React.createElement(Flex_1.Flex, { justifyContent: "space-between", alignItems: "center" },
                    !shouldCompact && React.createElement(Box_1.Box, { mr: 2 }, label),
                    React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: icon }))));
        }
        return (React.createElement(JoinedButton, __assign({}, toggleProps, { icon: React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: icon }) })));
    }
    return React.createElement(ToggleBase, __assign({}, toggleProps, { icon: React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: icon }) }));
};
var BaseDropDownButton = (function (_super) {
    __extends(BaseDropDownButton, _super);
    function BaseDropDownButton(props) {
        var _this = _super.call(this, props) || this;
        _this.handleOutsideClick = function (e) {
            if (_this.dropdownNode && !_this.dropdownNode.contains(e.target)) {
                if (_this.state.open) {
                    _this.removeListener();
                    _this.setState({
                        open: false,
                    });
                }
            }
        };
        _this.toggle = function () {
            var isNextOpen = !_this.state.open;
            if (isNextOpen) {
                window.document.addEventListener('click', _this.handleOutsideClick);
            }
            else {
                _this.removeListener();
            }
            _this.setState({
                open: isNextOpen,
            });
        };
        _this.removeListener = function () {
            window.document.removeEventListener('click', _this.handleOutsideClick);
        };
        _this.state = {
            open: false,
        };
        return _this;
    }
    BaseDropDownButton.prototype.componentWillUnmount = function () {
        if (this.state.open) {
            this.removeListener();
        }
    };
    BaseDropDownButton.prototype.render = function () {
        var _this = this;
        var _a;
        var _b = this.props, dropUp = _b.dropUp, alignRight = _b.alignRight, children = _b.children, label = _b.label, border = _b.border, joined = _b.joined, noListFormat = _b.noListFormat, outline = _b.outline, className = _b.className, onClick = _b.onClick, items = _b.items, props = __rest(_b, ["dropUp", "alignRight", "children", "label", "border", "joined", "noListFormat", "outline", "className", "onClick", "items"]);
        return (React.createElement(Wrapper, __assign({ className: className, onClick: joined ? onClick : undefined }, props, { ref: function (node) { return (_this.dropdownNode = node); } }),
            joined ? (React.createElement(Toggle, __assign({}, props, { onClick: onClick, outline: outline, joined: joined, label: label, handler: this.toggle, open: this.state.open, items: items }))) : (React.createElement("span", null,
                React.createElement(ButtonBase, __assign({}, props, { onClick: onClick, outline: outline }), label),
                React.createElement(Toggle, __assign({}, props, { outline: outline, onMouseEnter: utils_1.stopEvent, handler: this.toggle, open: this.state.open, items: items })))),
            this.state.open && React.createElement(Fixed_1.Fixed, { onClick: this.toggle }),
            this.state.open && (React.createElement(MenuBase, { dropUp: dropUp, alignRight: alignRight, onClick: function () { return (!items ? _this.toggle() : undefined); }, maxHeight: utils_1.px((_a = this.props.listMaxHeight) !== null && _a !== void 0 ? _a : 300) }, items
                ? items.map(function (itemGroup, i) { return (React.createElement(Box_1.Box, { key: i },
                    itemGroup.map(function (item, j) { return (React.createElement(Item, { px: 3, py: 1, onClick: function (event) {
                            if (!item.disabled && item.onClick) {
                                item.onClick(event);
                                _this.toggle();
                            }
                        }, tooltip: item.tooltip, disabled: item.disabled, danger: item.danger, hasActionFn: !!item.onClick, key: j }, item.content)); }),
                    i < items.length - 1 && React.createElement(Divider_1.Divider, null))); })
                : React.Children.map(children, function (child, i) {
                    if (noListFormat) {
                        return child;
                    }
                    if (!child) {
                        return;
                    }
                    if (child.type === Divider_1.Divider) {
                        return child;
                    }
                    return (React.createElement(Item, { px: 3, py: 1, hasActionFn: false, key: i }, child));
                })))));
    };
    return BaseDropDownButton;
}(React.Component));
exports.DropDownButton = asRendition_1.default(BaseDropDownButton, [], ['color', 'bg', 'backgroundColor']);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6;
