/// <reference types="react" />
import type { JSONSchema7 as JSONSchema } from 'json-schema';
import { FilterRenderMode, FiltersView } from '.';
import { DropDownButtonProps } from '../DropDownButton';
declare const ViewsMenu: (props: ViewsMenuProps) => JSX.Element;
export interface ViewsMenuProps {
    buttonProps?: DropDownButtonProps;
    disabled?: boolean;
    dark?: boolean;
    views: FiltersView[];
    schema: JSONSchema;
    hasMultipleScopes?: boolean;
    setFilters: (filters: JSONSchema[]) => void;
    deleteView: (view: FiltersView) => any;
    renderMode?: FilterRenderMode[];
    compact?: boolean[];
}
export default ViewsMenu;
