"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EXTRA_FORMATS = void 0;
var mermaid_1 = require("../../extra/Form/mermaid");
var markdown_1 = require("../../extra/Form/markdown");
var captcha_1 = require("../../extra/Form/captcha");
exports.EXTRA_FORMATS = [
    { name: 'markdown', format: '.*', widget: markdown_1.MarkdownWidget },
    { name: 'mermaid', format: '.*', widget: mermaid_1.MermaidWidget },
    { name: 'captcha', format: '.*', widget: captcha_1.CaptchaWidget },
];
