"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithFallback = exports.Default = void 0;
var utils_1 = require("../../stories/utils");
var _1 = require(".");
var balena_png_1 = __importDefault(require("../../stories/assets/balena.png"));
exports.default = {
    title: 'Core/Img',
    component: _1.Img,
};
var Template = utils_1.createTemplate(_1.Img);
exports.Default = utils_1.createStory(Template, {
    src: balena_png_1.default,
});
exports.WithFallback = utils_1.createStory(Template, {
    src: 'imgthatfails',
    fallback: 'https://picsum.photos/200/300',
});
