"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DisabledTextWidget = void 0;
var react_1 = __importDefault(require("react"));
var Copy_1 = require("../../Copy");
var Flex_1 = require("../../Flex");
var Txt_1 = require("../../Txt");
var types_1 = require("../types");
var widget_util_1 = require("./widget-util");
exports.DisabledTextWidget = widget_util_1.widgetFactory('DisabledText', {}, [
    types_1.JsonTypes.string,
    types_1.JsonTypes.number,
])(function (_a) {
    var value = _a.value;
    var val = typeof value !== 'string' ? value.toString() : value;
    return (react_1.default.createElement(Flex_1.Flex, null,
        react_1.default.createElement(Txt_1.Txt, { maxWidth: "300px", truncate: true, title: val, color: "#b3b6b9", monospace: true }, val),
        val.length > 45 && react_1.default.createElement(Copy_1.Copy, { content: val })));
});
