"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithDifferentColor = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var _1 = require(".");
var Input_1 = require("../Input");
var SurroundingOverlayDemo = function (props) {
    var _a = react_1.default.useState(null), rect = _a[0], setRect = _a[1];
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(_1.SurroundingOverlay, __assign({ rect: rect }, props)),
        react_1.default.createElement(Input_1.Input, { mb: 4, type: "text", onFocus: function (e) { return setRect(e.target.getBoundingClientRect()); }, onBlur: function () { return setRect(null); } }),
        react_1.default.createElement(Input_1.Input, { mb: 4, type: "text", onFocus: function (e) { return setRect(e.target.getBoundingClientRect()); }, onBlur: function () { return setRect(null); } }),
        react_1.default.createElement(Input_1.Input, { type: "datetime-local", onFocus: function (e) { return setRect(e.target.getBoundingClientRect()); }, onBlur: function () { return setRect(null); } })));
};
exports.default = {
    title: 'Core/SurroundingOverlay',
    component: _1.SurroundingOverlay,
};
var Template = utils_1.createTemplate(SurroundingOverlayDemo);
exports.Default = utils_1.createStory(Template, {});
exports.WithDifferentColor = utils_1.createStory(Template, {
    layerColor: 'black',
    padding: 5,
});
