/// <reference types="react" />
export declare type PartialDomRect = Partial<Omit<DOMRect, 'toJSON'>>;
export declare const getBoundingContainerRect: (element: EventTarget & HTMLDivElement) => PartialDomRect | null;
export interface SurroundingOverlayProps {
    rect: PartialDomRect | null;
    layerColor?: string;
    padding?: number;
    opacity?: number;
}
export declare const SurroundingOverlay: ({ rect, layerColor, padding, opacity, }: SurroundingOverlayProps) => JSX.Element | null;
