"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TagLabel = void 0;
var faCopy_1 = require("@fortawesome/free-solid-svg-icons/faCopy");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var copy_to_clipboard_1 = __importDefault(require("copy-to-clipboard"));
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var Txt_1 = require("../Txt");
var useTranslation_1 = require("../../hooks/useTranslation");
var utils_1 = require("../../utils");
var Label = styled_components_1.default(Txt_1.Txt.span)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: inline-flex;\n\talign-items: stretch;\n\tjustify-content: stretch;\n\tmax-width: 100%;\n\theight: 30px;\n\tpadding: 7px;\n\tborder: 0.5px solid ", ";\n\tfont-size: 11px;\n\tfont-weight: bold;\n\tborder-radius: 3px;\n\tcolor: ", ";\n\tbackground-color: ", ";\n\tposition: relative;\n"], ["\n\tdisplay: inline-flex;\n\talign-items: stretch;\n\tjustify-content: stretch;\n\tmax-width: 100%;\n\theight: 30px;\n\tpadding: 7px;\n\tborder: 0.5px solid ", ";\n\tfont-size: 11px;\n\tfont-weight: bold;\n\tborder-radius: 3px;\n\tcolor: ", ";\n\tbackground-color: ", ";\n\tposition: relative;\n"])), function (props) { return props.theme.colors.info.main; }, function (props) { return props.theme.colors.info.main; }, function (props) { return props.theme.colors.info.light; });
var TagText = styled_components_1.default(Txt_1.Txt.span)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tdisplay: inline-block;\n\tmax-width: 100%;\n\toverflow: hidden;\n\ttext-overflow: ellipsis;\n\twhite-space: nowrap;\n\n\t", ":hover & {\n\t\topacity: 0.5;\n\t}\n"], ["\n\tdisplay: inline-block;\n\tmax-width: 100%;\n\toverflow: hidden;\n\ttext-overflow: ellipsis;\n\twhite-space: nowrap;\n\n\t", ":hover & {\n\t\topacity: 0.5;\n\t}\n"])), Label);
var TagValue = styled_components_1.default.span(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tfont-weight: normal;\n"], ["\n\tfont-weight: normal;\n"])));
var CopyButton = styled_components_1.default.span(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\tposition: absolute;\n\ttop: 0;\n\tright: 0;\n\tbottom: 0;\n\tleft: 0;\n\tdisplay: flex;\n\talign-items: center;\n\tjustify-content: center;\n\tcolor: ", ";\n\tuser-select: none;\n\tcursor: pointer;\n\tvisibility: hidden;\n\n\t", ":hover & {\n\t\tvisibility: visible;\n\t}\n"], ["\n\tposition: absolute;\n\ttop: 0;\n\tright: 0;\n\tbottom: 0;\n\tleft: 0;\n\tdisplay: flex;\n\talign-items: center;\n\tjustify-content: center;\n\tcolor: ", ";\n\tuser-select: none;\n\tcursor: pointer;\n\tvisibility: hidden;\n\n\t", ":hover & {\n\t\tvisibility: visible;\n\t}\n"])), function (props) { return props.theme.colors.text.main; }, Label);
var FaCopyBase = function (props) { return React.createElement(react_fontawesome_1.FontAwesomeIcon, __assign({ icon: faCopy_1.faCopy }, props)); };
var FaCopy = styled_components_1.default(FaCopyBase)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n\tbackground-color: ", ";\n\tbox-shadow: 0 0 1px 3px ", ";\n"], ["\n\tbackground-color: ", ";\n\tbox-shadow: 0 0 1px 3px ", ";\n"])), function (props) { return props.theme.colors.info.light; }, function (props) { return props.theme.colors.info.light; });
var getTagCompositeText = function (tag) {
    var text = tag.tag_key;
    if (tag.value) {
        text = text + " : " + tag.value;
    }
    return text;
};
exports.TagLabel = function (props) {
    var t = useTranslation_1.useTranslation().t;
    var tag = props.tag, maxValueLength = props.maxValueLength, wrapValue = props.wrapValue, _a = props.showTagKey, showTagKey = _a === void 0 ? true : _a, _b = props.placeholder, placeholder = _b === void 0 ? t('no_data.no_value') : _b, restProps = __rest(props, ["tag", "maxValueLength", "wrapValue", "showTagKey", "placeholder"]);
    if (!tag) {
        return null;
    }
    var compositeTagString = getTagCompositeText(tag);
    var tagCopyValue = showTagKey
        ? compositeTagString
        : tag.value || placeholder;
    return (React.createElement(Label, __assign({ onClick: utils_1.stopEvent, title: compositeTagString }, restProps),
        React.createElement(TagText, { tooltip: {
                text: t('actions_messages.copied'),
                trigger: 'click',
            } },
            showTagKey && tag.tag_key,
            showTagKey && tag.value && ': ',
            tag.value && (React.createElement(TagValue, { style: { whiteSpace: wrapValue ? 'normal' : 'nowrap' } }, maxValueLength && tag.value.length > maxValueLength
                ? tag.value.substring(0, maxValueLength) + "..."
                : tag.value)),
            !showTagKey && !tag.value && (React.createElement(TagValue, null,
                React.createElement("i", null, placeholder))),
            React.createElement(CopyButton, { onClick: function () { return copy_to_clipboard_1.default(tagCopyValue); } },
                React.createElement(FaCopy, null)))));
};
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
