"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MinMaxRows = exports.AutoRows = exports.ReadOnly = exports.Disabled = exports.Monospace = exports.WithPlaceholder = exports.Default = void 0;
var utils_1 = require("../../stories/utils");
var _1 = require(".");
exports.default = {
    title: 'Core/Textarea',
    component: _1.Textarea,
};
var Template = utils_1.createTemplate(_1.Textarea);
exports.Default = utils_1.createStory(Template, {});
exports.WithPlaceholder = utils_1.createStory(Template, {
    placeholder: 'Type something...',
});
exports.Monospace = utils_1.createStory(Template, {
    placeholder: 'Type something...',
    monospace: true,
});
exports.Disabled = utils_1.createStory(Template, {
    disabled: true,
});
exports.ReadOnly = utils_1.createStory(Template, {
    readOnly: true,
});
exports.AutoRows = utils_1.createStory(Template, {
    autoRows: true,
});
exports.MinMaxRows = utils_1.createStory(Template, {
    minRows: 4,
    maxRows: 8,
});
