"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpanComponent = exports.InColor = exports.Styled = exports.Default = void 0;
var utils_1 = require("../../stories/utils");
var _1 = require(".");
exports.default = {
    title: 'Core/Txt',
    component: _1.Txt,
};
var Template = utils_1.createTemplate(_1.Txt);
var SpanTemplate = utils_1.createTemplate(_1.Txt.span);
exports.Default = utils_1.createStory(Template, {
    children: 'Standard',
});
exports.Styled = utils_1.createStory(Template, {
    children: 'Styled text',
    bold: true,
    italic: true,
    monospace: true,
});
exports.InColor = utils_1.createStory(Template, {
    children: 'Colored text',
    color: 'blue',
});
exports.SpanComponent = utils_1.createStory(SpanTemplate, {
    children: 'Space   is   preserved',
    whitespace: 'pre',
});
