/// <reference types="react" />
import { AutoUIContext, AutoUIModel, AutoUIBaseResource } from '../schemaOps';
import { ActionData } from '../schemaOps';
interface CreateProps<T extends AutoUIBaseResource<T>> {
    model: AutoUIModel<T>;
    autouiContext: AutoUIContext<T>;
    hasOngoingAction: boolean;
    onActionTriggered: (data: ActionData<T>) => void;
}
export declare const Create: <T extends AutoUIBaseResource<T>>({ model, autouiContext, hasOngoingAction, onActionTriggered, }: CreateProps<T>) => JSX.Element | null;
export {};
