/// <reference types="react" />
import { AutoUIContext, AutoUIModel, AutoUIBaseResource } from '../schemaOps';
import { ActionData } from '../schemaOps';
interface UpdateProps<T extends AutoUIBaseResource<T>> {
    model: AutoUIModel<T>;
    autouiContext: AutoUIContext<T>;
    selected: T[];
    hasOngoingAction: boolean;
    onActionTriggered: (data: ActionData<T>) => void;
}
export declare const Update: <T extends AutoUIBaseResource<T>>({ model, autouiContext, selected, hasOngoingAction, onActionTriggered, }: UpdateProps<T>) => JSX.Element | null;
export {};
