"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Filters = void 0;
var react_1 = __importDefault(require("react"));
var PersistentFilters_1 = require("./PersistentFilters");
var Filters_1 = require("../../../components/Filters");
var useHistory_1 = require("../../../hooks/useHistory");
exports.Filters = function (_a) {
    var schema = _a.schema, filters = _a.filters, views = _a.views, changeFilters = _a.changeFilters, changeViews = _a.changeViews, autouiContext = _a.autouiContext, renderMode = _a.renderMode, onSearch = _a.onSearch;
    var history = useHistory_1.useHistory();
    return (react_1.default.createElement(react_1.default.Fragment, null, !!history ? (react_1.default.createElement(PersistentFilters_1.PersistentFilters, { compact: [true, true, false, false], viewsRestorationKey: autouiContext.resource + "__views", history: history, schema: schema, filters: filters, views: views, onFiltersUpdate: changeFilters, onViewsUpdate: changeViews, renderMode: renderMode !== null && renderMode !== void 0 ? renderMode : ['add', 'search', 'views'], onSearch: onSearch })) : (react_1.default.createElement(Filters_1.Filters, { compact: [true, true, false, false], schema: schema, filters: filters, views: views, onFiltersUpdate: changeFilters, onViewsUpdate: changeViews, renderMode: renderMode !== null && renderMode !== void 0 ? renderMode : ['add', 'search', 'views'], onSearch: onSearch }))));
};
