/// <reference types="react" />
import { FilterSignature, FiltersProps } from '../../../components/Filters';
import type { History } from 'history';
export interface ListQueryStringFilterObject {
    n: FilterSignature['field'];
    o: FilterSignature['operator'];
    v: FilterSignature['value'];
}
interface PersistentFiltersProps extends FiltersProps {
    viewsRestorationKey: string;
    history: History;
}
export declare const PersistentFilters: ({ schema, views, filters, onViewsUpdate, onFiltersUpdate, viewsRestorationKey, history, onSearch, ...otherProps }: PersistentFiltersProps) => JSX.Element;
export {};
