"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LensSelection = void 0;
var react_1 = __importDefault(require("react"));
var Box_1 = require("../../../components/Box");
var Button_1 = require("../../../components/Button");
var ButtonGroup_1 = require("../../../components/ButtonGroup");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
exports.LensSelection = function (_a) {
    var lenses = _a.lenses, lens = _a.lens, setLens = _a.setLens, rest = __rest(_a, ["lenses", "lens", "setLens"]);
    if (lenses.length <= 1) {
        return null;
    }
    return (react_1.default.createElement(Box_1.Box, __assign({}, rest),
        react_1.default.createElement(ButtonGroup_1.ButtonGroup, null, lenses.map(function (item) {
            return (react_1.default.createElement(Button_1.Button, { key: item.slug, active: lens && lens.slug === item.slug, "data-test": "lens-selector--" + item.slug, "data-slug": item.slug, onClick: function () { return setLens(item); }, tooltip: {
                    text: item.data.label,
                    placement: 'bottom',
                }, icon: react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: item.data.icon }), quartenary: true, outline: true }));
        }))));
};
