/// <reference types="react" />
import type { JSONSchema } from '../../components/Renderer/types';
import { ActionMethods } from '.';
import { OpenApiJson } from './openApiJson';
export interface ActionSidebarProps {
    resourceName: string;
    openApiJson: OpenApiJson;
    action: ActionMethods;
    schema: JSONSchema;
    id?: string;
    onClose?: () => void;
}
export declare const ActionSidebar: ({ resourceName, openApiJson, action, schema, id, onClose, }: ActionSidebarProps) => JSX.Element;
