"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var _1 = require(".");
var logo_svg_1 = __importDefault(require("./demo/logo.svg"));
var openApi_json_1 = __importDefault(require("./demo/openApi.json"));
exports.default = {
    title: 'Extra/AutoUIApp',
    component: _1.AutoUIApp,
};
var DemoAutoUIApp = function () {
    return (react_1.default.createElement(_1.AutoUIApp, { title: "AutoUIApp Demo", logo: logo_svg_1.default, openApiJson: openApi_json_1.default }));
};
var Template = utils_1.createTemplate(DemoAutoUIApp);
exports.Default = utils_1.createStory(Template, {});
