"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Navbar = void 0;
var react_1 = __importDefault(require("react"));
var Flex_1 = require("../../components/Flex");
var Heading_1 = require("../../components/Heading");
exports.Navbar = function (_a) {
    var title = _a.title, logo = _a.logo, flexProps = __rest(_a, ["title", "logo"]);
    return (react_1.default.createElement(Flex_1.Flex, __assign({ bg: "secondary.main", alignItems: "center" }, flexProps),
        logo && react_1.default.createElement("img", { src: logo, alt: title, height: "50px" }),
        react_1.default.createElement(Heading_1.Heading, { color: "white" }, title)));
};
