export declare const getNameFromSlug: (slug: string) => string;
export interface PokedexInterface {
    id: number;
    Name: string;
    biometrics?: {
        Height: number;
        Weight: number;
    };
    Description?: string;
    Category?: string;
    nationality?: string;
    Abilities?: string[];
    secondaryAbilities?: string[];
    pokedex_number?: number;
    caught?: boolean;
}
declare const _default: ({
    id: number;
    Name: string;
    biometrics: {
        Height: number;
        Weight: number;
    };
    Description: string;
    Category: string;
    nationality: string;
    Abilities: string[];
    secondaryAbilities: string[];
    pokedex_number: number;
    caught: boolean;
    first_seen?: undefined;
    Tag?: undefined;
} | {
    id: number;
    Name: string;
    biometrics: {
        Height: number;
        Weight: number;
    };
    Description: string;
    Category: string;
    nationality: string;
    Abilities: string[];
    secondaryAbilities: string[];
    pokedex_number: number;
    first_seen: string;
    caught: boolean;
    Tag?: undefined;
} | {
    id: number;
    Name: string;
    biometrics: {
        Height: number;
        Weight: number;
    };
    Description: string;
    Category: string;
    nationality: string;
    Abilities: string[];
    secondaryAbilities: string[];
    first_seen: string;
    pokedex_number: number;
    caught: boolean;
    Tag: {
        tag_name: string;
        tag_value: string;
    }[];
})[];
export default _default;
