import * as React from 'react';
import { DeviceType } from './models';
export declare type OsOptions = ReturnType<typeof getUserOs>;
export declare const osTitles: Record<OsOptions, string>;
export declare const getUserOs: () => "unknown" | "linux" | "windows" | "osx";
export declare const ApplicationInstructions: React.MemoExoticComponent<({ deviceType, templateData, }: {
    deviceType: DeviceType;
    templateData: {
        dockerImage: string;
    };
}) => JSX.Element>;
