"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Collapsible = void 0;
var faMinus_1 = require("@fortawesome/free-solid-svg-icons/faMinus");
var faPlus_1 = require("@fortawesome/free-solid-svg-icons/faPlus");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var React = __importStar(require("react"));
var Box_1 = require("../../components/Box");
var Button_1 = require("../../components/Button");
exports.Collapsible = function (_a) {
    var children = _a.children, collapsible = _a.collapsible, initiallyCollapsed = _a.initiallyCollapsed, title = _a.title;
    var _b = React.useState(initiallyCollapsed), isCollapsed = _b[0], setIsCollapsed = _b[1];
    if (!collapsible) {
        return React.createElement(Box_1.Box, { mb: 3 }, children);
    }
    return (React.createElement(Box_1.Box, { mb: 3 },
        React.createElement(Button_1.Button, { plain: true, icon: isCollapsed ? (React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faPlus_1.faPlus })) : (React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faMinus_1.faMinus })), onClick: function () { return setIsCollapsed(function (x) { return !x; }); } }, title),
        !isCollapsed && React.createElement(Box_1.Box, { mt: 3 }, children)));
};
