import { __makeTemplateObject } from "tslib";
import styled from 'styled-components';
import asRendition from '../../asRendition';
import { Flex } from '../Flex';
import { withProps } from '../../utils';
var setDefaultProps = withProps(function (props) {
    return Object.assign({
        p: [3, 4],
        minHeight: "80vh",
        flexDirection: "column",
        alignItems: "center",
        justifyContent: "center",
    }, props);
});
var setBgImage = function (bgImage) { return (bgImage ? "url(" + bgImage + ")" : 'none'); };
var Base = styled(Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tbackground-size: cover;\n\tbackground-position: center;\n\tbackground-image: ", ";\n"], ["\n\tbackground-size: cover;\n\tbackground-position: center;\n\tbackground-image: ", ";\n"])), function (props) { return setBgImage(props.backgroundImage); });
export var Banner = asRendition(Base, [setDefaultProps]);
var templateObject_1;
