import { __assign, __makeTemplateObject, __rest } from "tslib";
import { faCopy } from '@fortawesome/free-regular-svg-icons/faCopy';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import copyToClipboard from 'copy-to-clipboard';
import * as React from 'react';
import styled from 'styled-components';
import { px } from '../../utils';
import { Box } from '../Box';
var ClipboardContainer = styled(Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tcursor: pointer;\n\tfont-size: 0.875em;\n"], ["\n\tcursor: pointer;\n\tfont-size: 0.875em;\n"])));
var CopyContainer = styled(Box)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tdisplay: inline-flex;\n\talign-items: center;\n\t", " {\n\t\tvisibility: ", ";\n\t\tsvg {\n\t\t\tmargin: ", ";\n\t\t}\n\t}\n\n\t&:hover {\n\t\t", " {\n\t\t\tvisibility: visible;\n\t\t}\n\t}\n"], ["\n\tdisplay: inline-flex;\n\talign-items: center;\n\t", " {\n\t\tvisibility: ", ";\n\t\tsvg {\n\t\t\tmargin: ", ";\n\t\t}\n\t}\n\n\t&:hover {\n\t\t", " {\n\t\t\tvisibility: visible;\n\t\t}\n\t}\n"])), ClipboardContainer, function (props) { return (props.show === 'always' ? 'visible' : 'hidden'); }, function (props) { return "0 " + px(props.theme.space[1]); }, ClipboardContainer);
var BaseCopy = function (_a) {
    var content = _a.content, show = _a.show, children = _a.children, onClick = _a.onClick, onCopy = _a.onCopy, otherProps = __rest(_a, ["content", "show", "children", "onClick", "onCopy"]);
    var normalizedText = (content || '').toString().trim();
    return (React.createElement(CopyContainer, __assign({ show: !!children ? show : 'always' }, otherProps),
        children,
        React.createElement(ClipboardContainer, { tooltip: { text: 'Copied!', trigger: 'click' }, onClick: function (e) {
                e.stopPropagation();
                e.preventDefault();
                copyToClipboard(normalizedText);
                if (onClick) {
                    onClick(normalizedText);
                }
                onCopy === null || onCopy === void 0 ? void 0 : onCopy(e);
            } },
            React.createElement(FontAwesomeIcon, { icon: faCopy }))));
};
export var Copy = BaseCopy;
var templateObject_1, templateObject_2;
