import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { DataGrid } from '.';
import { Card, Txt } from '../..';
export default {
    title: 'Core/DataGrid',
    component: DataGrid,
};
var Template = createTemplate(DataGrid);
export var Default = createStory(Template, {
    items: [1, 2, 3, 4, 5, 6],
    itemMinWidth: ['180px', '260px', '320px'],
    itemMaxWidth: ['360px', '520px', '640px'],
    getItemKey: function (i) { return i; },
    renderItem: function (i) { return (React.createElement(Card, null,
        React.createElement(Txt, { fontSize: 4, align: "center" }, i))); },
});
