import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { Flex } from '.';
import { Box } from '../..';
export default {
    title: 'Core/Flex',
    component: Flex,
};
var Template = createTemplate(Flex);
export var Default = createStory(Template, {
    children: (React.createElement(React.Fragment, null,
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "red" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "blue" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "green" }))),
});
export var Justified = createStory(Template, {
    justifyContent: 'space-between',
    children: (React.createElement(React.Fragment, null,
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "red" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "blue" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "green" }))),
});
export var ColumnDirection = createStory(Template, {
    flexDirection: 'column',
    children: (React.createElement(React.Fragment, null,
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "red" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "blue" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "green" }))),
});
export var Wrap = createStory(Template, {
    flexWrap: 'wrap',
    children: (React.createElement(React.Fragment, null,
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "red" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "red" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "blue" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "green" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "red" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "blue" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "green" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "red" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "blue" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "green" }))),
});
export var FlexOnChildren = createStory(Template, {
    flexWrap: 'wrap',
    children: (React.createElement(React.Fragment, null,
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "red" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "red" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, flex: "1", bg: "red" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "blue" }),
        React.createElement(Box, { style: { height: 200, width: 200 }, bg: "green" }))),
});
