import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { List } from '.';
import { Link, Txt } from '../..';
var defaultChildren = [
    React.createElement(Txt, null,
        "You can put ",
        React.createElement(Link, { href: '#' }, "a link")),
    React.createElement(Txt, null,
        "And also some ",
        React.createElement("code", null, "code")),
    React.createElement(Txt, null,
        "Multiline text",
        React.createElement(Txt, null, "that breaks into multiple lines")),
];
export default {
    title: 'Core/List',
    component: List,
};
var Template = createTemplate(List);
export var Default = createStory(Template, {
    children: defaultChildren,
});
export var Ordered = createStory(Template, {
    ordered: true,
    children: defaultChildren,
});
