import * as React from 'react';
import { DropProps } from 'grommet';
import { TooltipArrowProps } from '../../internal/TooltipArrow';
export interface PopoverOptions {
    placement?: TooltipArrowProps['placement'];
}
export interface PopoverProps extends React.PropsWithChildren<DropProps & PopoverOptions> {
    onDismiss: () => any;
}
export declare const Popover: {
    ({ placement, target, onDismiss, children, ...rest }: PopoverProps): JSX.Element;
    defaultProps: {
        placement: string;
    };
};
