import { __assign } from "tslib";
import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { ProgressBar } from '.';
var ProgressBarDemo = function (props) {
    var _a;
    var _b = React.useState((_a = props.value) !== null && _a !== void 0 ? _a : 0), value = _b[0], setValue = _b[1];
    React.useEffect(function () {
        var interval = setInterval(function () {
            setValue(function (val) { return (val > 100 ? 0 : val + 1); });
        }, 250);
        return function () { return clearInterval(interval); };
    }, []);
    return (React.createElement(ProgressBar, __assign({}, props, { value: value }),
        value,
        "%"));
};
export default {
    title: 'Core/ProgressBar',
    component: ProgressBar,
};
var Template = createTemplate(ProgressBarDemo);
export var Default = createStory(Template, {
    value: 10,
});
export var DifferentColor = createStory(Template, {
    value: 10,
    danger: true,
});
export var Emphasized = createStory(Template, {
    value: 10,
    emphasized: true,
});
