import { __assign, __makeTemplateObject } from "tslib";
import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { RendererPlayground } from './RendererPlayground';
import { Renderer } from '.';
import examples from './examples';
import { createGlobalStyle } from 'styled-components';
var GlobalStyle = createGlobalStyle(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  html, body, #root {\n    height: 100%;\n  }\n  #root,\n  #root > div,\n  #root > div > div {\n    display: flex;\n    flex: 1;\n    min-width: 0;\n  }\n  .storybook-readme-story > div {\n    margin: 0 !important;\n  }\n"], ["\n  html, body, #root {\n    height: 100%;\n  }\n  #root,\n  #root > div,\n  #root > div > div {\n    display: flex;\n    flex: 1;\n    min-width: 0;\n  }\n  .storybook-readme-story > div {\n    margin: 0 !important;\n  }\n"])));
export default {
    title: 'Core/Renderer',
    component: Renderer,
};
var Template = createTemplate(Renderer);
var PlaygroundTemplate = createTemplate(RendererPlayground);
export var Default = createStory(Template, __assign({}, examples['An object with various properties']));
export var Playground = createStory(PlaygroundTemplate, {
    examples: examples,
    flex: 1,
    height: '100%',
});
Playground.decorators = [
    function (Story) { return (React.createElement(React.Fragment, null,
        React.createElement(GlobalStyle, null),
        React.createElement(Story, null))); },
];
var templateObject_1;
