import { __assign, __rest } from "tslib";
import * as React from 'react';
import get from 'lodash/get';
import { Heading } from '../../Heading';
import { UiOption } from './ui-options';
import { widgetFactory } from './widget-util';
import { JsonTypes } from '../types';
var HeadingWidget = widgetFactory('Heading', {
    size: __assign(__assign({}, UiOption.number), { enum: [1, 2, 3, 4, 5, 6] }),
}, [JsonTypes.string])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, size = _a.size, props = __rest(_a, ["value", "schema", "uiSchema", "size"]);
    if (value == null) {
        return null;
    }
    var HeadingComponent = get(Heading, "h" + size, Heading.h3);
    return React.createElement(HeadingComponent, __assign({}, props), value.toString());
});
export default HeadingWidget;
