import React from 'react';
import { InternalBadgeProps } from '../Badge';
import { FlexProps } from '../Flex';
export interface MenuItem {
    className?: string;
    href: string;
    title: string;
    badge?: InternalBadgeProps;
    icon?: React.ReactNode;
}
declare const MenuItem: import("styled-components").StyledComponent<React.ForwardRefExoticComponent<import("../Box").BoxProps & React.RefAttributes<HTMLDivElement>>, any, FlexProps & {
    isCurrent: boolean;
}, never>;
export declare const Menu: ({ items, isCollapsed, ...props }: {
    items: MenuItem[];
    isCollapsed: boolean;
} & FlexProps) => JSX.Element;
export {};
