/// <reference types="react" />
import { FlexProps } from '../Flex';
import { Crumb } from '../Breadcrumbs';
import { MenuItem } from './Menu';
export interface SidebarProps extends FlexProps {
    menuItems: MenuItem[];
    crumbs?: Crumb[];
    showBreadcrumbs?: boolean;
    isCollapsed?: boolean;
    additionalComponents?: JSX.Element | null;
    setIsCollapsed?: (isCollapsed: boolean) => void;
}
export declare const Sidebar: ({ menuItems, crumbs, showBreadcrumbs, isCollapsed, additionalComponents, setIsCollapsed, ...props }: SidebarProps) => JSX.Element;
