import * as React from 'react';
import { RenditionSystemProps } from '../../common-types';
export interface InternalStepsProps extends React.HTMLAttributes<HTMLElement> {
    bordered?: boolean;
    ordered?: boolean;
    activeStepIndex?: number;
    titleText?: string;
    titleIcon?: React.ReactNode;
    onClose?: () => void;
}
declare type statusOptions = 'none' | 'pending' | 'completed';
export interface StepProps {
    children: string;
    status: statusOptions;
    onClick?: () => void;
}
export declare const Step: React.FunctionComponent<StepProps>;
export declare type StepsProps = InternalStepsProps & RenditionSystemProps;
export declare const Steps: React.ForwardRefExoticComponent<InternalStepsProps & import("../../common-types").StyledSystemProps & import("../../common-types").Tooltip & React.RefAttributes<HTMLDivElement>>;
export {};
