import { __assign } from "tslib";
import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { SurroundingOverlay } from '.';
import { Input } from '../Input';
var SurroundingOverlayDemo = function (props) {
    var _a = React.useState(null), rect = _a[0], setRect = _a[1];
    return (React.createElement(React.Fragment, null,
        React.createElement(SurroundingOverlay, __assign({ rect: rect }, props)),
        React.createElement(Input, { mb: 4, type: "text", onFocus: function (e) { return setRect(e.target.getBoundingClientRect()); }, onBlur: function () { return setRect(null); } }),
        React.createElement(Input, { mb: 4, type: "text", onFocus: function (e) { return setRect(e.target.getBoundingClientRect()); }, onBlur: function () { return setRect(null); } }),
        React.createElement(Input, { type: "datetime-local", onFocus: function (e) { return setRect(e.target.getBoundingClientRect()); }, onBlur: function () { return setRect(null); } })));
};
export default {
    title: 'Core/SurroundingOverlay',
    component: SurroundingOverlay,
};
var Template = createTemplate(SurroundingOverlayDemo);
export var Default = createStory(Template, {});
export var WithDifferentColor = createStory(Template, {
    layerColor: 'black',
    padding: 5,
});
