import * as React from 'react';
import { mount } from 'enzyme';
import { SurroundingOverlay, Provider } from '../..';
describe('SurroundingOverlay component', function () {
    it('should render the SurroundingOverlay', function () {
        var rect = {
            top: 0,
            left: 0,
            bottom: 0,
            right: 0,
            x: 0,
            y: 0,
            height: undefined,
            width: 800,
        };
        var component = mount(React.createElement(Provider, null,
            React.createElement(SurroundingOverlay, { rect: rect })));
        expect(component.find(SurroundingOverlay).children()).toHaveLength(4);
    });
    it('should not render the SurroundingOverlay', function () {
        var rect = null;
        var component = mount(React.createElement(Provider, null,
            React.createElement(SurroundingOverlay, { rect: rect })));
        expect(component.find(SurroundingOverlay).children()).toHaveLength(0);
    });
});
