import { __makeTemplateObject } from "tslib";
import * as React from 'react';
import styled from 'styled-components';
import { stopEvent } from '../../utils';
import { Box } from '../Box';
import { DropDownButton } from '../DropDownButton';
import { Txt } from '../Txt';
var Wrapper = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: flex;\n\talign-items: center;\n\twhite-space: nowrap;\n"], ["\n\tdisplay: flex;\n\talign-items: center;\n\twhite-space: nowrap;\n"])));
export var CustomColumnHeader = function (props) {
    var columnInfo = props.columnInfo, items = props.items, disabledItems = props.disabledItems, label = props.label, setColumn = props.setColumn;
    var configured = !!columnInfo.title;
    var memoizedItems = React.useMemo(function () { return [
        items.map(function (item) {
            var disabled = disabledItems.includes(item);
            return {
                content: React.createElement(Box, { key: item }, item),
                disabled: disabled,
                tooltip: disabled
                    ? "This " + label.toLowerCase() + " is already selected"
                    : undefined,
                onClick: function () { return setColumn(columnInfo, item); },
            };
        }),
    ]; }, [items, disabledItems, label, setColumn, columnInfo]);
    return (React.createElement(DropDownButton, { label: React.createElement(Wrapper, null,
            React.createElement(Txt, { bold: !configured },
                label,
                ":"),
            configured ? (React.createElement(Txt, { m: "0 3px", bold: true }, columnInfo.title)) : (React.createElement(Txt, { m: "0 3px", color: "text.light" }, "Choose " + label.toLowerCase()))), plain: true, joined: true, alignRight: true, onClick: stopEvent, items: memoizedItems }));
};
var templateObject_1;
