/// <reference types="react" />
import { ResourceTagInfo } from './models';
import { TFunction } from '../../hooks/useTranslation';
interface AddTagFormProps<T> {
    t: TFunction;
    itemType: string;
    existingTags: Array<ResourceTagInfo<T>>;
    overwritableTags?: Array<ResourceTagInfo<T>>;
    addTag: (tag: ResourceTagInfo<T>) => void;
}
export declare const AddTagForm: <T extends {}>({ itemType, existingTags, overwritableTags, addTag, }: AddTagFormProps<T>) => JSX.Element;
export {};
