import { __makeTemplateObject } from "tslib";
import { faCaretDown } from '@fortawesome/free-solid-svg-icons/faCaretDown';
import { faCaretUp } from '@fortawesome/free-solid-svg-icons/faCaretUp';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import * as React from 'react';
import styled from 'styled-components';
var CaretButtonBase = styled.button(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: flex;\n\talign-items: center;\n\tjustify-content: center;\n\tpadding: 0;\n\tborder: 0 none;\n\tfont-size: 16px;\n\tfont-weight: normal;\n\tcolor: #b3b6b9;\n\tbackground-color: transparent;\n"], ["\n\tdisplay: flex;\n\talign-items: center;\n\tjustify-content: center;\n\tpadding: 0;\n\tborder: 0 none;\n\tfont-size: 16px;\n\tfont-weight: normal;\n\tcolor: #b3b6b9;\n\tbackground-color: transparent;\n"])));
var CaretIconContainer = styled.span(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tfont-size: 14px;\n"], ["\n\tfont-size: 14px;\n"])));
export var CaretButton = function (_a) {
    var isExpanded = _a.isExpanded, onClick = _a.onClick, children = _a.children, className = _a.className;
    return (React.createElement(CaretButtonBase, { className: className, onClick: onClick },
        React.createElement("span", null, children),
        React.createElement(CaretIconContainer, { style: { marginLeft: children ? '4px' : 0 } }, isExpanded ? (React.createElement(FontAwesomeIcon, { icon: faCaretUp })) : (React.createElement(FontAwesomeIcon, { icon: faCaretDown })))));
};
var templateObject_1, templateObject_2;
