/// <reference types="react" />
import { AutoUIContext, AutoUIBaseResource } from '../schemaOps';
interface TagsProps<T> {
    selected: T[];
    autouiContext: AutoUIContext<T>;
    setIsBusyMessage: (message: string | undefined) => void;
    onDone: () => void;
    refresh?: () => void;
}
export declare const Tags: <T extends AutoUIBaseResource<T>>({ selected, autouiContext, setIsBusyMessage, refresh, onDone, }: TagsProps<T>) => JSX.Element | null;
export {};
