import { __assign, __rest } from "tslib";
import React from 'react';
import { Flex } from '../../components/Flex';
import { Heading } from '../../components/Heading';
export var Navbar = function (_a) {
    var title = _a.title, logo = _a.logo, flexProps = __rest(_a, ["title", "logo"]);
    return (React.createElement(Flex, __assign({ bg: "secondary.main", alignItems: "center" }, flexProps),
        logo && React.createElement("img", { src: logo, alt: title, height: "50px" }),
        React.createElement(Heading, { color: "white" }, title)));
};
