import { __assign, __makeTemplateObject, __rest } from "tslib";
import React from 'react';
import { NavLink } from 'react-router-dom';
import styled from 'styled-components';
import { useLocation } from 'react-router-dom';
import { Flex } from '../../components/Flex';
import { Txt } from '../../components/Txt';
var SidebarWrapper = styled(Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\toverflow: auto;\n\tbackground: ", ";\n\tflex-direction: column;\n\tflex-wrap: nowrap;\n"], ["\n\toverflow: auto;\n\tbackground: ", ";\n\tflex-direction: column;\n\tflex-wrap: nowrap;\n"])), function (props) { return props.theme.colors.secondary.main; });
var MenuItem = styled(Flex)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\theight: 48px;\n\tcursor: pointer;\n\tborder-bottom: 1px solid\n\t\t", ";\n\tborder-left: ", ";\n\tbackground: ", ";\n\n\t&:hover {\n\t\tbackground: ", ";\n\t}\n"], ["\n\theight: 48px;\n\tcursor: pointer;\n\tborder-bottom: 1px solid\n\t\t",
    ";\n\tborder-left: ",
    ";\n\tbackground: ",
    ";\n\n\t&:hover {\n\t\tbackground: ",
    ";\n\t}\n"])), function (props) {
    return props.isCurrent
        ? props.theme.colors.quartenary.light
        : props.theme.colors.tertiary.dark;
}, function (props) {
    return props.isCurrent ? "2px solid " + props.theme.colors.primary.main : 'none';
}, function (props) {
    return props.isCurrent
        ? props.theme.colors.quartenary.light
        : props.theme.colors.secondary.dark;
}, function (props) {
    return props.isCurrent
        ? props.theme.colors.quartenary.light
        : props.theme.colors.tertiary.dark;
});
export var Sidebar = function (_a) {
    var openApiJson = _a.openApiJson, _b = _a.isCollapsed, isCollapsed = _b === void 0 ? false : _b, flexProps = __rest(_a, ["openApiJson", "isCollapsed"]);
    var pathname = useLocation().pathname;
    var menuItems = React.useMemo(function () {
        return Object.entries(openApiJson.components.schemas)
            .filter(function (_a) {
            var key = _a[0], value = _a[1];
            return !key.endsWith('-create') &&
                !key.endsWith('-update') &&
                !!value.title;
        })
            .map(function (_a) {
            var _b, _c;
            var key = _a[0], value = _a[1];
            return ({
                resource: key.substring(key.indexOf('.') + 1),
                title: (_c = (_b = value.title) === null || _b === void 0 ? void 0 : _b.split('_')) === null || _c === void 0 ? void 0 : _c.join(' '),
            });
        });
    }, [openApiJson]);
    return (React.createElement(SidebarWrapper, __assign({}, flexProps), menuItems.map(function (item) {
        var isCurrent = pathname.split('/').some(function (i) { return i === item.resource; });
        return (React.createElement(NavLink, { key: item.resource, to: "/" + item.resource },
            React.createElement(MenuItem, { width: "100%", isCurrent: isCurrent, px: 3, py: 2, flexDirection: "row", alignItems: "center" },
                React.createElement(Txt.span, { bold: true, fontSize: 2, style: { lineHeight: 1.33 }, color: isCurrent ? 'text.main' : 'quartenary.main', display: isCollapsed ? 'none' : undefined, truncate: true, tooltip: item.title }, item.title))));
    })));
};
var templateObject_1, templateObject_2;
