import { faMinus } from '@fortawesome/free-solid-svg-icons/faMinus';
import { faPlus } from '@fortawesome/free-solid-svg-icons/faPlus';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import * as React from 'react';
import { Box } from '../../components/Box';
import { Button } from '../../components/Button';
export var Collapsible = function (_a) {
    var children = _a.children, collapsible = _a.collapsible, initiallyCollapsed = _a.initiallyCollapsed, title = _a.title;
    var _b = React.useState(initiallyCollapsed), isCollapsed = _b[0], setIsCollapsed = _b[1];
    if (!collapsible) {
        return React.createElement(Box, { mb: 3 }, children);
    }
    return (React.createElement(Box, { mb: 3 },
        React.createElement(Button, { plain: true, icon: isCollapsed ? (React.createElement(FontAwesomeIcon, { icon: faPlus })) : (React.createElement(FontAwesomeIcon, { icon: faMinus })), onClick: function () { return setIsCollapsed(function (x) { return !x; }); } }, title),
        !isCollapsed && React.createElement(Box, { mt: 3 }, children)));
};
